

angular.module('Landers.UI', [])
    .directive('bool', ['Flat', function(Flat){
        return {
            restrict : 'A',
            require : 'ngModel',
            template : '<span class="label label-success">是</span><span class="label label-warning">否</span>',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                var $childs = $ele.children();
                $scope.$watch(ngModel, function(new_value){
                    var bool = !!~~new_value;
                    if (bool) {
                        $childs.eq(0).show();
                        $childs.eq(1).hide();
                    } else {
                        $childs.eq(0).hide();
                        $childs.eq(1).show();
                    }
                });

            }
        }
    }])
    .directive('disabledWhen', ['$compile', 'Runtime', 'Helpers', function($compile, Runtime, Helpers){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var datkey = $attrs['disabledWhen'];
                var runtime = Runtime.make(myScope);
                var cache = runtime.get('watchers') || {};

                if ( cache[datkey] ) {
                    cache[datkey].push($ele);
                    runtime.set('watchers', cache);
                } else {
                    cache[datkey] = [$ele];
                    runtime.set('watchers', cache);
                }

                myScope.$watch(datkey, function(newValue){
                    cache[datkey].map(function($e){
                        if (newValue) $e.addClass('disabled').prop('disabled', true);
                        else $e.removeClass('disabled').prop('disabled', false);
                    });
                });
            }
        };
    }])
    .directive('buttonRadio', ['$timeout', 'Flat', 'Helpers',  function($timeout, Flat, Helpers){
        return {
            restrict : 'A',
            link : function($scope, $group, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var doActive = function($button){
                    if ($button.hasClass('disabled') || $button.prop('disabled') || $button.attr('disabled')) {
                        return false;
                    }
                    var $input = $button.children();
                    var ngModel = $input.attr('ng-model');

                    Flat.set(myScope, ngModel, $input.val());

                    var a = ngModel.split('.');
                    a.splice(1, 0, '$errors');
                    var errorKey = a.join('.');
                    Flat.set(myScope, errorKey, '');

                    if (!myScope.$$phase) myScope.$apply();

                    return true;
                };

                var ngModel = $attrs['ngModel'];
                if (ngModel) {
                    $scope.$watch(ngModel, function(value){
                        var $buttons = $group.children();

                        $buttons.click(function(){
                            return doActive($(this));
                        });

                    });
                } else {
                    (function(){
                        var $buttons = $group.children();
                        if ( !$buttons.length ) {
                            return setTimeout(arguments.callee, 300);
                        }

                        $buttons.click(function(){
                            return doActive($(this));
                        });
                    })();
                }
            }
        };
    }])
    .directive('copyText', [function(){
        Landers.loader.jsm('jquery.clipboard');
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var fromKey = $attrs['copyTextFrom'];
                var $from = fromKey ? $(fromKey) : $();
                (function(){
                    var text = $attrs['copyText'];
                    var value = $from.val() || $from.text();
                    text = text || value;
                    if ($.fn.zclip && text) {
                        $ele.zclip({copy: text});
                    } else {
                        setTimeout(arguments.callee, 300);
                    }
                })();
            }
        };
    }])
    .directive('dataslider', ['Flat', '$compile', 'Helpers', function(Flat, $compile, Helpers){
        if (!Landers.data_slide) {
            Landers.loader.jsm(['landers.slider,true']);
        }
        return {
            restrict : 'E',
            link : function($scope, $ele, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var configKey = $attrs['config'];
                var ngModel = $attrs['ngModel'];
                var slideStop = $attrs['slideStop'];
                var id = $attrs['sliderId'];
                var infoKey = $attrs['info'];

                var html = '';
                html += '<div class="slider-wrapper">';
                html += '   <div data-config="{{ ' + configKey + ' }}" class="data_slider">';
                html += '        <input ng-model="' + ngModel + '" type="hidden"/>';
                html += '   </div>';
                html += '</div>';
                $ele = $($compile(html)(myScope)).replaceAll($ele);

                var destroyWatch;
                var $slider = $ele.find('.data_slider');
                if ( id ) $slider.attr('id', id);

                (function(){
                    var self1 = arguments.callee;

                    //设置监听
                    if (!destroyWatch) {
                        destroyWatch = myScope.$watch(ngModel, function(newValue){
                            if ( newValue !== undefined ) {
                                (function(){
                                    var self2 = arguments.callee;
                                    $slider.find('input').val(newValue);
                                    try {
                                        $slider.slider('option', 'value', newValue)
                                               .trigger('slide', {value:newValue});
                                    } catch (e){
                                        setTimeout(self2, 200);
                                    }
                                })();
                            }
                        });
                        $ele.find('.ui-slider').attachWatcher(destroyWatch);
                    }

                    var config = Flat.get(myScope, configKey);

                    //config 有值了，Landers.data_slide才能正常执行
                    if ( Landers.data_slide && config ) {

                        config = angular.fromJson(config);
                        Flat.set(myScope, ngModel, config.value);

                        //必须延时，否则虽然config有值，但未反应到html中
                        setTimeout(function(){
                            Landers.data_slide($slider, {
                                info : infoKey ? '{{' + infoKey + '}}' : '',
                                slidestop:function (event, ui){
                                    Flat.set(myScope, ngModel, ui.value);

                                    if (slideStop) {
                                        var fun = Flat.get(myScope, slideStop);
                                        if (fun) fun($slider);
                                    }
                                }
                            });
                        }, 200);
                    } else {
                        setTimeout(self1, 300);
                    }
                })();
            }
        };
    }])
    .directive('money', ['Flat', '$compile', function(Flat, $compile){
        return {
            restrict : 'E',
            link : function($scope, $ele, $attrs) {
                var amount = $attrs['amount'];
                if ( !amount ) return;
                var unit = 'unit' in $attrs ? $attrs['unit'] : '元';
                var classname = $attrs['class'];

                var html = [];
                html.push('<span ng-show="' + amount + ' !== undefined">');
                html.push('<em class="cny"></em>');
                if ( $attrs['uiSref'] ) {
                    html.push('<a ui-sref="' + $attrs['uiSref'] + '" class="amount ' + classname + '">{{' + amount + '}}</a>');
                } else {
                    html.push('<span class="amount ' + classname + '" ng-bind-html="' + amount + '"></span>');
                }
                html.push('<em class="unit-cny">' + unit + '</em>');
                html.push('</span>');
                html = html.join(' ');
                $ele.replaceWith($compile(html)($scope));
            }
        };
    }])

    .directive('bootstrapTooltip', [function(){
        return {
            restrict : 'C',
            link : function($scope, $ele, $attrs){
                $ele.tooltip();
            }
        }
    }])
    .directive('protip', [function(){
        if ( !$.protip ) Landers.loader.jsm('jquery.protip,true');
        var is_protip = false;
        return {
            restrict : 'C',
            link : function($scope, $ele, $attrs){
                var self = arguments.callee;
                if ( !$ele.attr('data-pt-size') ) {
                    $ele.attr('data-pt-size', 'small');
                }
                if ( !$ele.attr('data-pt-scheme') ) {
                    $ele.attr('data-pt-scheme', 'black');
                }

                if ($.protip && $ele.attr('data-pt-title')) {
                    $.protip();
                    $ele.on('protipshow', function(itemInstance){
                        var $me = $(itemInstance.target);
                        var t = $me.data('ptShow');
                        if (t !== undefined && t !== true) {
                            setTimeout(function(){
                                $me.protipHide();
                            }, 5);
                        }
                    });
                } else {
                    setTimeout(function(){
                        self($scope, $ele, $attrs);
                    }, 500);
                }
            }
        };
    }])
    .factory('DatatimePickerHelper', ['Flat', '$timeout', function(Flat, $timeout){
        function DatatimePickerHelper(scope, ngModel, $begin, $end) {
            var ngModelBegin = $begin.attr('ng-model');
            var ngModelEnd = $end.attr('ng-model');
            this.set = function(begin, end){
                $timeout(function(){
                    begin = begin || '';
                    end = end || '';
                    if (ngModelBegin) {
                        Flat.set(scope, ngModelBegin, begin);
                    } else {
                        $begin.val(begin);
                    }
                    if (ngModelEnd) {
                        Flat.set(scope, ngModelEnd, end);
                    } else {
                        $end.val(end);
                    }
                    if (ngModel) {
                        Flat.set(scope, ngModel, begin || end ? [begin, end] : undefined);
                    }
                    if (ngModelBegin || ngModelEnd || ngModel) scope.$apply();
                }, 100);
            };
        }

        return {
            make : function(scope, ngModel, $begin, $end){
                return new DatatimePickerHelper(scope, ngModel, $begin, $end);
            },
            locale : {
                'zh-cn' : {
                    today : '定位今天',
                    clear : '清空',
                    close : '关闭',
                    selectMonth: '选择月份',
                    prevMonth: '上月',
                    nextMonth: '下月',
                    selectYear: '选择年份',
                    prevYear: '上年',
                    nextYear: '下年',
                    selectDecade: 'Select Decade',
                    prevDecade: 'Previous Decade',
                    nextDecade: 'Next Decade',
                    prevCentury: 'Previous Century',
                    nextCentury: 'Next Century',
                    pickHour: '选取小时',
                    incrementHour: '增加小时',
                    decrementHour: '减少小时',
                    pickMinute: '选取分钟',
                    incrementMinute: '增加分钟',
                    decrementMinute: '减少分钟',
                    pickSecond: '选取秒',
                    incrementSecond: '增加秒',
                    decrementSecond: '减少秒',
                    togglePeriod: 'Toggle Period',
                    selectTime: '选择时间'
                }
            }
        };
    }])
    .directive('bootstrapDatetimeRangePicker', ['Flat', '$timeout', 'DatatimePickerHelper', function(Flat, $timeout, DatatimePickerHelper){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                var $begin = $ele.siblings('.datetime-begin');
                var $end = $ele.siblings('.datetime-end');
                var helper = DatatimePickerHelper.make($scope, ngModel, $begin, $end);

                var format = $ele.data('format') || 'YYYY-MM-DD hh:mm A';

                var defaults = {
                    showISOWeekNumbers: true,
                    timePicker24Hour: true,
                    alwaysShowCalendars: true,
                    opens: 'left',
                    timePicker: true,
                    timePickerIncrement: 1,
                    locale: {
                        format: format,
                        cancelLabel: 'Clear'
                    }
                };
                var config = $ele.data();
                delete config.$ngModelController;
                config = angular.extend({}, defaults, config);

                $ele.daterangepicker(config, function(begin, end, label) {
                    begin = begin.format(config.format);
                    end = end.format(config.format);
                    helper.set(begin, end);
                });

                $ele.on('cancel.daterangepicker', function(ev, picker) {
                    $ele.val('');
                });
                $ele.val('');
            }
        };
    }])

    .directive('bootstrapDatetimePicker', ['Flat', '$timeout', 'DatatimePickerHelper', function(Flat, $timeout, DatatimePickerHelper){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                $ele.addClass('datetime-picker');
                var $begin = $ele.children('.datetime-begin');
                var $end = $ele.children('.datetime-end');
                var helper = DatatimePickerHelper.make($scope, ngModel, $begin, $end);

                var defaults = {
                    format : 'YYYY-MM-DD HH:mm:ss',
                    showClose:true,
                    showClear:true,
                    sideBySide:false,
                    showTodayButton: true,
                    locale: 'zh-cn',
                    tooltips:DatatimePickerHelper.locale['zh-cn']
                };
                var config = $ele.data();
                delete config.$ngModelController;
                delete config.minDate;
                delete config.maxDate;
                config = angular.extend({}, defaults, config);

                $begin.add($end).datetimepicker(config);

                var values = {begin:'', end:''};
                $begin.on('dp.change', function(e){
                    if ( e.date) {
                        values.begin = e.date.format(config.format);
                    } else {
                        values.begin = '';
                    }
                    helper.set(values.begin, values.end);
                });
                $end.on('dp.change', function(e){
                    if ( e.date ) {
                        values.end = e.date.format(config.format);
                    } else {
                        values.end = '';
                    }
                    helper.set(values.begin, values.end);
                });
                $begin.add($end).on('dp.show', function(){
                    var $wrapper = $(this).next();
                    var dtp = $(this).data('DateTimePicker');
                    var minDate = $(this).data('minDate');
                    if (minDate) dtp.minDate(minDate);
                    var maxDate = $(this).data('maxDate');
                    if (maxDate) dtp.maxDate(maxDate);

                    setTimeout(function(){
                        $wrapper.find('.timepicker-picker a.btn').removeClass('btn');
                    }, 200);
                });
            }
        };
    }])
    .directive('ngUploader', ['$timeout', '$compile', 'Upload', 'Helpers', 'Flat',  function($timeout, $compile, Upload, Helpers, Flat){
        var counter = 0;
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                if ($ele.data('uploadId')) return;

                var uploadId = 'uploadFiles' + (counter++);

                //将uploadId暴露到外面，以便外部可以控制调用
                $ele.data('uploadId', uploadId);

                var ngmodel = $attrs['ngModel'];

                var upload_url = $attrs['uploadUrl'];
                upload_url = Helpers.domainUrl(ENV.hosts.storage, upload_url);

                var onUpload = $attrs['onUpload'];
                var onReset = $attrs['onReset'];

                var props = [], tip = [];

                var accept = $attrs['accept'];
                if (accept) props.push('accept="'+ accept +'"');

                var ngf_max_width = $attrs['ngfMaxWidth'];
                if (ngf_max_width) {
                    props.push('ngf-max-width="'+ ngf_max_width +'"');
                }

                var ngf_max_height = $attrs['ngfMaxHeight'];
                if (ngf_max_height) {
                    props.push('ngf-max-height="'+ ngf_max_height +'"');
                }

                var ngf_max_size = $attrs['ngfMaxSize'];
                if (ngf_max_size) {
                    props.push('ngf-max-size="'+ ngf_max_size +'"');
                    tip.push('文件大小不超过' + ngf_max_size);
                }

                var upload_class = $attrs['uploadClass'];
                if (upload_class) props.push('class="'+ upload_class +'"');

                props = props.join(' ');
                tip = tip.join('，');
                tip = '选择上传附件' + (tip.length ? '，' + tip : '' );

                var html = '';
                html += '<input type="hidden" ng-model="' + ngmodel + '" class="form-control">';
                html += '<button type="file" ngf-select="$upload.' + uploadId + '.upload($file, $invalidFiles)" ' + props + '>' + tip + '</button>';
                html += '<div class="progress upload-progress" ng-show="$upload.' + uploadId + '.f.progress>0">';
                html += '   <div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="80" aria-valuemin="0" aria-valuemax="100" style="width: {{$upload.' + uploadId + '.f.progress}}%">';
                html +=         '<span class="sr-only" ng-bind="$upload.' + uploadId + '.f.progress + \'%\'"></span>';
                html += '   </div>';
                html += '</div>';
                $ele.append($compile(html)($scope));

                //upload的命名空间
                $scope.$upload = $scope.$upload || {};
                var $UL = $scope.$upload;
                $UL[uploadId] = {
                    tip : tip,
                    event : $ele.find('button'),
                    onUpload : onUpload ? Flat.get($scope, onUpload) : null,
                    onReset : onReset ? Flat.get($scope, onReset) : null,
                    upload : function(file, errFiles){
                        var _this = this;
                        var $event = _this.event;

                        if (errFiles && errFiles.length) {
                            var message, errFile = errFiles[0];
                            switch (errFile.$error) {
                                case 'maxSize' :
                                    message = '文件大小不能超过' + errFile.$errorParam;
                                    break;
                                case 'maxWidth' :
                                    message = '图片宽度不能超过' + errFile.$errorParam + 'px';
                                    break;
                                case 'maxHeight' :
                                    message = '图片高度不能超过' + errFile.$errorParam + 'px';
                                    break;
                                default :
                                    message = errFile.$error + errFile.$errorParam;
                                    break;
                            }
                            return Landers.response.msgbox({
                                success : false,
                                message : message
                            });
                        }


                        if (file) {
                            $UL[uploadId].f = file;
                            file.upload = Upload.upload({
                                url: upload_url,
                                data: {file: file}
                            });
                            file.upload.then(
                                function (response) {
                                    $timeout(function () {
                                        $UL.uploading = false;
                                        file.result = response.data;
                                        Flat.set($scope, ngmodel, file.result.data.url);
                                        _this.onUpload && _this.onUpload(file.result.data);
                                        Helpers.enable($event).text('上传成功');
                                    }, 200);
                                },
                                function (response) {
                                    $timeout(function () {
                                        $UL.uploading = false;
                                        if (response.status > 0) {
                                            $UL.errorMsg = response.status + ': ' + response.data;
                                        }
                                        Helpers.enable($event).text('上传失败');
                                    }, 200);
                                },
                                function (evt) {
                                    $UL.uploading = true;
                                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                                    Helpers.disable($event).text('已上传' + file.progress + '%...，请稍候...');
                                }
                            );
                        }

                    },
                    reset : function(){
                        var _this = this;
                        var $event = _this.event;
                        Flat.set($scope, ngmodel, '');
                        $event.text(_this.tip);
                        _this.onReset && _this.onReset(file.result.data);
                    }
                };
            }
        };
    }])
    .directive('landersRaty', ['Flat', function(Flat){
        return {
            restrict : 'A',
            template : '<div class="raty-star center"></div><div class="raty-hint"></div>',
            link : function($scope, $ele, $attrs){
                var $star = $ele.find('.raty-star');
                var ngmodel = $attrs['ngModel'];
                var $hint = $ele.find('.raty-hint');
                var config = {};
                if ($attrs['ratyNumber']) config.number = ~~$attrs['ratyNumber'];
                if ($attrs['ratyScore']) config.score = ~~$attrs['ratyScore'];

                if ($attrs['ratyTargetType']) config.targetType = $attrs['ratyTargetType'];
                if ($attrs['ratyPath']) config.path = $attrs['ratyPath'];
                if ($attrs['ratySize']) config.size = ~~$attrs['ratySize'];
                config = angular.extend({}, {
                    number: 10, // 多少个星星设置
                    score: 10,   // 初始值是设置
                    targetType: 'number',   //类型选择，number是数字值，hint，是设置的数组值
                    path      : '/static/img/star/',
                    cancelOff : 'cancel-off-big.png',
                    cancelOn  : 'cancel-on-big.png',
                    size      : 24,
                    starHalf  : 'star-half-big.png',
                    starOff   : 'star-off-big.png',
                    starOn    : 'star-on-big.png',
                    cancel    : false,
                    targetKeep: true,
                    precision : false,//是否包含小数
                    click: function(score, evt) {
                        if (ngmodel) Flat.set($scope, ngmodel, score);
                    }
                }, config);
                if (ngmodel) Flat.set($scope, ngmodel, config.score);

                if (config.target === true) config.target = $hint;
                Landers.loader.jsm('jquery.raty', function(){
                    $star.raty(config);
                });
            }
        };
    }])
    // .directive('validateHelper', ['Flat', function(Flat){
    //     return {
    //         restrict : 'A',
    //         link : function($scope, $form, $attrs){
    //             $form.find('input, select, textarea').change(function(){
    //                 var ele = $(this);
    //                 if (!ele.val()) return;
    //                 var ngmodel = ele.attr('ng-model');
    //                 var arr = ngmodel.split('.');
    //                 var key = arr[arr.length-1];
    //                 var datakey = ['$errors', $attrs['errorsKey'], key].join('.');
    //                 Flat.set($scope, datakey, '');
    //                 $scope.$apply();
    //             })
    //         }
    //     }
    // }])
    .directive('remedySelect', function() {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs, ngModel){
                var allow_mouseout = true;
                var blur_click = function(){
                    allow_mouseout = false;
                    setTimeout(function(){allow_mouseout = true;}, 100);
                };
                $element.mouseover(function(){
                    $(this).addClass('onhover');
                })
                .mouseout(function(){
                    if (allow_mouseout) {
                        $(this).removeClass('onhover onfocus');
                    }
                })
                .blur(function(){
                    blur_click();
                    $(this).removeClass('onhover onfocus');
                })
                .click(function(){
                    blur_click();
                    $(this).addClass('onfocus').removeClass('onhover');
                });
            }
        };
    })
    .directive('landersTreeSelect', ['$timeout', function($timeout) {
        return {
            restrict : 'A',
            require: 'ngModel',
            link : function($scope, $element, $attrs, ngModel){
                Landers.loader.jsm(['landers.treeselect'], function(){
                    var source = $attrs.source;
                    $scope.$watch(source, function(newValue){
                        $element.children().remove();
                        Landers.treeselect.select({
                            contain: $element, data:newValue, root:['', '选择分类']
                        });
                        var precache = $element.data('precache');
                        $element.val(precache);
                    });
                    $scope.$apply();

                    $scope.$watch($attrs['ngModel'], function(newValue){
                        $element.data('precache', newValue);
                        $element.val(newValue);
                    });
                });
            }
        };
    }])
    .directive('landersTab', ['Flat', function(Flat) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                Landers.loader.jsm(['landers.tab,true'], function(){
                    $element.itab();
                });
            }
        };
    }])
    .directive('icheck', ['$timeout', '$parse', function ($timeout, $parse) {
        return {
            require: 'ngModel',
            link: function($scope, element, $attrs, ngModel) {

                return $timeout(function() {
                    var value;
                    value = $attrs['value'];

                    $scope.$watch($attrs['ngModel'], function(newValue){
                        $(element).icheck('update');
                    });

                    Landers.loader.jsm('jquery.icheck,true', function(){
                        return $(element).icheck({
                            checkboxClass: 'icheckbox_square-blue',
                            radioClass: 'iradio_square-blue'

                        }).on('ifChanged', function(event) {
                            if ($(element).attr('type') === 'checkbox' && $attrs['ngModel']) {
                                $scope.$apply(function() {
                                    return ngModel.$setViewValue(event.target.checked);
                                });
                            }
                            if ($(element).attr('type') === 'radio' && $attrs['ngModel']) {
                                return $scope.$apply(function() {
                                    return ngModel.$setViewValue(value);
                                });
                            }
                        });
                    });

                });
            }
        };
    }])

    .directive('landersLabelauty', ['$timeout', 'Flat', 'Helpers', function($timeout, Flat, Helpers) {
        var css_loaded = false;
        Landers.loader.jsm(['jquery.labelauty']);
        return {
            restrict : 'A',
            require : '?ngModel',
            link : function($scope, $ele, $attrs) {
                if (!css_loaded) {
                    Landers.css.add('html input.labelauty + label > span.labelauty-unchecked-image + span.labelauty-unchecked, html input.labelauty + label > span.labelauty-checked-image + span.labelauty-checked {margin-left: 0px; }');
                    Landers.css.add('html input.labelauty + label > span.labelauty-unchecked-image, html input.labelauty + label > span.labelauty-checked-image {background-image:none; }');
                    css_loaded = true;
                }

                var myScope = Helpers.seekScope($scope, parseInt($attrs['useScope']));

                var ngmodel = $attrs['ngModel'];
                if (ngmodel) {
                    $ele.click(function(){
                        var val = $(this).val();
                        Flat.set(myScope, ngmodel, val);
                    });
                }

                setTimeout(function(){
                    var self = arguments.callee;
                    if ($.fn.labelauty) {
                        $ele.labelauty({ same_width:true, label:true });
                    } else {
                        setTimeout(self, 300);
                    }
                }, 300);
            }
        };
    }]);