var gulp = require('gulp');
var plugins = require('gulp-load-plugins')();
var watcher = {
    cache : {},
    set : function(task, files){
        if ( !this.cache[task] ) {
            gulp.watch(files, [task]);
            this.cache[task] = true;
        }
    }
};

var root = '.';
var lib = './lib';
var src = './src';
var common_files = [
        src + '/main.js',

        src + '/utils/for-jquery.js',
        src + '/utils/directive-includes.js',
        src + '/utils/directive-key-to-text.js',
        src + '/utils/directive-toggle-classes.js',
        src + '/utils/factory-base-service.js',
        src + '/utils/factory-data-convert.js',
        src + '/utils/factory-flat.js',
        src + '/utils/factory-helpers.js',
        src + '/utils/factory-http-interceptor.js',
        src + '/utils/factory-inject-service.js',
        src + '/utils/factory-list.js',
        src + '/utils/factory-listitem.js',
        src + '/utils/factory-location.js',
        src + '/utils/factory-runtime.js',
        src + '/utils/factory-tab-index.js',
        src + '/utils/filter-datetime.js',
        src + '/utils/filter-nl2br.js',
        src + '/utils/filter-nl2li.js',
        src + '/utils/filter-round.js',
        src + '/utils/provider-ajax.js',
        src + '/utils/provider-dialog.js',
        src + '/utils/service-route-menu.js',
        src + '/control/directive-list-status.js',
        src + '/control/directive-ui-alert-error.js',
        src + '/control/directive-checklist-model.js',
        src + '/control/directive-bool.js',
        src + '/control/directive-bootstrap-tooltip.js',
        src + '/control/directive-datatime-picker.js',
        src + '/control/directive-disabled-when.js',
        src + '/control/directive-icheck.js',
        src + '/control/directive-landers-pagebar.js',
        src + '/control/directive-protip.js',
        src + '/control/directive-remedy-select.js',
        src + '/control/directive-landers-name-value-inputer.js',
        src + '/control/directive-drop-select.js',
        src + '/control/directive-include-replace.js',
        src + '/control/directive-mcustomer-scroll.js',
        src + '/control/directive-iscroll.js',

        src + '/model-app/api.js',
        src + '/model-app/model.js',
        src + '/model-app/app.js',

        src + '/other/echarts.js',
];

gulp.task('ulan', function(){
    var files = [
        src + '/utils/factory-promise-loads.js',
        src + '/control/directive-money.js',
        src + '/control/directive-button-radio.js',
        src + '/control/directive-button-checkbox.js',
        src + '/control/directive-copy-text.js',
        src + '/control/directive-dataslider.js',
        src + '/utils/provider-gwebsocket.js',
        src + '/control/directive-ng-uploader.js',
        src + '/control/directive-landers-raty.js',
    ];
    files = common_files.concat(files);

    gulp.src(files)
        .pipe(plugins.concat('landers.ulan.angular.js'))
        // .pipe(plugins.uglify())
        .pipe(gulp.dest(root + '/'));
    watcher.set('ulan', files);
});

gulp.task('lwap', function(){
    var files = [
        src + '/control/directive-landers-attachment.js',
        src + '/control/directive-landers-tab.js',
        src + '/control/directive-landers-upload.js',
        src + '/control/directive-landers-tree-select.js',
        src + '/control/directive-ueditor.js',
        src + '/model-app/lwap.js',
    ];
    files = common_files.concat(files);
    gulp.src(files)
        .pipe(plugins.concat('landers.lwap.angular.js'))
        // .pipe(plugins.uglify())
        .pipe(gulp.dest(root + '/'));
    watcher.set('lwap', files);
});

gulp.task('lwap2', function(){
    var files = [
        src + '/utils/factory-promise-loads.js',
        src + '/control/directive-money.js',
        src + '/control/directive-button-radio.js',
        src + '/control/directive-button-checkbox.js',
        src + '/control/directive-copy-text.js',
        src + '/control/directive-dataslider.js',
        src + '/utils/provider-gwebsocket.js',
        src + '/control/directive-landers-raty.js',
        src + '/control/directive-landers-attachment.js',
        src + '/control/directive-landers-tab.js',
        src + '/control/directive-landers-upload.js',
        src + '/control/directive-landers-tree-select.js',
        src + '/control/directive-ueditor.js',
        src + '/control/directive-breadcrumbs.js'
    ];
    files = common_files.concat(files);
    gulp.src(files)
        .pipe(plugins.concat('landers.lwap2.angular.js'))
        .pipe(gulp.dest(root + '/'));
    watcher.set('lwap2', files);
});

gulp.task('default', ['ulan', 'lwap', 'lwap2']);

gulp.watch('gulpfile.js', ['default']);