;angular.module('Landers.angular', []);
if (window.$) {
    $.fn.attachWatcher = function(fn) {
        $(this).data('angularDestroyWatch', fn);
    };
    $.fn.destroyWatch = function(){
        var fn = $(this).data('angularDestroyWatch');
        if (fn) fn();
        return this;
    };
}
;angular.module('Landers.angular')
    .directive('includes', function($compile){
        return {
            restrict : 'A',
            link : function($scope, $ele, attrs) {
                var includes = attrs['includes'].split('|');
                var tpl = '<div ng-include src="$partial(\'{mod}\')"></div>';
                var tpls = [];
                angular.forEach(includes, function(item){
                    tpls.push(tpl.replace('{mod}', item));
                })
                var html = tpls.join('\n');
                $ele.children().html($compile(html)($scope));
            }
        }
    });
;angular.module('Landers.angular')
    .directive('keyToText', ['$timeout', 'Flat', function($timeout, Flat) {
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var arr = $attrs['keyToText'].split('|');
                var enums = Flat.get($scope, arr[0]);
                var monitorKey = arr[1];
                var textField = arr[2] ? arr[2] : 'text';
                var listener = function(newValue) {
                    var data = enums[newValue];
                    if (!data) return;

                    var html = data[textField] || data.text;
                    var $text = $ele.find('.key-to-text');
                    if ($text.length) $text.html(html);
                    else $ele.html(html);

                    if (!data._class) return;
                    for (var k in enums) $ele.removeClass(enums[k]['_class']);
                    $ele.addClass(data._class);
                };
                var monitorVal = monitorKey.match(/\[(.*)\]/);
                if (monitorVal) {
                    $scope.$watch( function(){return monitorVal[1];}, listener);
                } else {
                    $scope.$watch( monitorKey, listener);
                }
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('toggleClasses', ['Flat', '$timeout', function(Flat, $timeout) {
        return {
            restrict : 'A',
            // require : '?ngModel',
            link : function($scope, $ele, $attrs) {
                var arr1 = $attrs['toggleClasses'].split(',');
                var arr2 = arr1[0].split('|'), callback = arr1[1];

                $timeout(function(){
                    if (callback) {
                        callback = Flat.get($scope, callback);
                    };
                    $ele.data('ToggleClassIndex', 0)
                    .addClass(arr2[0]).click(function(){
                        var last_index = $ele.data('ToggleClassIndex');
                        var index = last_index + 1;
                        if (index >= arr2.length) index = 0;
                        for (var i=0; i<arr2.length; i++) $ele.removeClass(arr2[i]);
                        $ele.data('ToggleClassIndex', index).addClass(arr2[index]);
                        callback && callback(index, arr2[index]);
                    });
                }, 400);

            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('BaseService', ['Ajax', 'Runtime', function (Ajax, Runtime){
        function BaseService(scope, extend, events){
            this.ajax = Ajax.make();
            this.runtime = Runtime.make(scope);
            angular.extend(this, extend || {});
        }
        return {
            make:function(scope, extend, events) {
                return new BaseService(scope, extend, events);
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('DataConvert', function(){
        return {
            checkbox:function(xvar) {
                var ret;
                if (angular.isString(xvar)) {
                    xvar = angular.toJson(xvar);
                }
                if (angular.isArray(xvar)) {
                    ret = {};
                    angular.forEach(xvar, function(item){
                        ret[item] = true;
                    });
                } else {
                    if (angular.isObject(xvar)) {
                        ret = [];
                        for (var k in xvar) {
                            if (xvar[k]) ret.push(k);
                        }
                    }
                }
                return ret;
            }
        };
    });
;angular.module('Landers.angular')
    .factory('Flat', function () {
        function Flat(scope, J){
            var that = Flat;
            this.apply = function(){
                if (!scope.$$phase) scope.$apply();
                return this;
            };
            this.get = function(key, subkey) {
                return that.get(J, key, subkey);
            };
            this.pull = function(key) {
                var ret = that.pull(J, key);
                this.apply();
                return ret;
            };
            this.set = function(key, value, subkey){
                that.set(J, key, value, subkey);
                return this.apply();
            };
            this.setOnce = function(key, value, subkey){
                var ret = that.setOnce(J, key, value, subkey);
                this.apply();
                return ret;
            };
            this.delete = function(key) {
                that.delete(J, key);
                return this.apply();
            };
            this.clear = function(){
                that.clear(J);
                return this.apply();
            };
            this.extend = function(json, subkey){
                that.extend(J, json, subkey);
                return this.apply();
            };
            this.cut = function(key, index) {
                that.cut(J, key, index);
                return this.apply();
            };
            this.copy = function(key, start, end) {
                that.copy(J, key, start, end);
                return this.apply();
            };
            this.shift = function(key) {
                that.shift(J, key);
                return this.apply();
            };
            this.unshift = function(key, value) {
                that.unshift(J, key, value);
                return this.apply();
            };
            this.push = function(key, value){
                that.push(J, key, value);
                return this.apply();
            };
            this.pop = function(key) {
                that.pop(J, key);
                return this.apply();
            };
        }
        angular.extend(Flat, {
            make : function(scope, J) {
                return new Flat(scope, J);
            },
            parse : function(J, key, subkey){
                if (subkey !== null && subkey !== undefined && subkey !== '') key += '.' + subkey;
                var a = key.split('.');
                J = J || {};
                if (a.length == 1) {
                    return {
                        obj:J, key:key
                    };
                } else {
                    for (var i=0; i<a.length-1; i++) {
                        J = J || {};
                        if ( ! (a[i] in J) ) {
                            J[a[i]] = {};
                        }
                        J[a[i]] = J[a[i]] || {};
                        J = J[a[i]];
                    }
                    return {
                        obj:J,
                        key:a[i]
                    };
                }
            },
            get : function(J, key, subkey) {
                var parse = this.parse(J, key, subkey);
                return parse.obj[parse.key];
            },
            pull : function(J, key){
                var ret = this.get(J, key);
                this.delete(J, key);
                return ret;
            },
            set : function(J, key, value, subkey){
                var parse = this.parse(J, key, subkey);
                // parse.obj = parse.obj || {}; //promote 为空时
                parse.obj[parse.key] = value;
                return this;
            },
            setOnce : function(J, key, value, subkey){
                var ret = this.get(J, key, subkey);
                if ( ret ) return ret;
                this.set(J, key, value, subkey);
                return value;
            },
            delete : function(J, key) {
                var parse = this.parse(J, key);
                delete parse.obj[parse.key];
                return this;
            },
            clear : function(J) {
                for (var k in J) delete J[k];
                J = {};
                return this;
            },
            extend : function(J, jdat, subkey) {
                if (subkey) {
                    var value = this.get(J, subkey) || {};
                    angular.extend(value, jdat);
                    this.set(J, subkey, value);
                } else {
                    for (var key in jdat) {
                        this.set(J, key, jdat[key]);
                    }
                }
                return this;
            },
            cut : function(J, key, index) {
                var parse = this.parse(J, key);
                parse.obj[parse.key].splice(index, 1);
                return parse.obj[parse.key];
            },
            copy : function(J, key, start, end) {
                var parse = this.parse(J, key);
                console.log(parse.obj);
                return parse.obj[parse.key].slice(start, end);
            },
            shift : function(J, key) {
                var parse = this.parse(J, key);
                parse.obj[parse.key].shift();
                return this;
            },
            unshift : function(J, key, value) {
                var parse = this.parse(J, key);
                try {
                    parse.obj[parse.key].unshift(value);
                }catch(e){
                    console.log(J);
                    console.log(key);
                    console.log(value);
                }
                return this;
            },
            push : function(J, key, value){
                var parse = this.parse(J, key);
                parse.obj[parse.key] = parse.obj[parse.key] || [];
                parse.obj[parse.key].push(value);
                return this;
            },
            pop : function(J, key) {
                var parse = this.parse(J, key);
                parse.obj[parse.key].pop();
                return this;
            }
        });

        return Flat;
    });
;angular.module('Landers.angular')
    .factory('Helpers', ['Flat', function(Flat){
        return {
            // seekScopeByDeep:function(scope, deep) {
            //     deep = parseInt(deep);
            //     var myScope = scope;
            //     if (!deep) return myScope;
            //     for (var i = 1; i <= deep; i++) {
            //         if (myScope.$parent) {
            //             myScope = myScope.$parent;
            //         } else {
            //             break;
            //         }
            //     }
            //     return myScope;
            // },

            seekScope : function(scope, parentId) {
                var myScope = scope;
                if ( !parentId) return myScope;
                while (myScope.$id != parentId) {
                    if (myScope.$parent) {
                        myScope = myScope.$parent;
                    } else {
                        break;
                    }
                }
                return myScope;
            },
            toJqEle : function($event) {
                if (!$event) return $();
                var obj = angular.isElement($event) ? $event : $event.target;
                return angular.element(obj);
            },
            disable : function($event){
                $event = this.toJqEle($event);
                return Landers.helpers.disable($event);
            },
            enable : function($event) {
                $event = this.toJqEle($event);
                return Landers.helpers.enable($event);
            },
            // showFormErrors : function(scope, key, rspn) {
            //     var errors = rspn.errors;
            //     if (errors) {
            //         for (var k in errors) {
            //             var datakey = ['$errors', key, k].join('.');
            //             Flat.set(scope, datakey, errors[k][0]);
            //         }
            //     }
            //     rspn.message = rspn.message || '提交的数据还存在不足！';
            //     Landers.response.msgbox(rspn);
            // },
            // clearFormErrors : function(scope, key) {
            //     Flat.set(scope, key + '.errors', {} );
            // },
            domainUrl : function(domainUrl, url) {
                if (!domainUrl) return url;
                var len = domainUrl.length;
                var pre = Landers.utils.str.left(url, len);
                if (pre === domainUrl) return url;
                else return domainUrl + url;
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('HttpInterceptor', ['$log', '$q', '$location', function($log, $q, $location) {
        return {
            response: function(response) {
                var deferred = $q.defer();
                deferred.resolve(response);
                return deferred.promise;
            },

            responseError : function(rejection){
                var deferred = $q.defer();
                deferred.reject(rejection);
                return deferred.promise;
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('InjectService', ['$ocLazyLoad', '$injector', function($ocLazyLoad, $injector){
        var injected = {};
        return {
            urls:function(urls, callback){
                $ocLazyLoad.load(urls).then(callback);
            },
            module : function(urls, injects) {
                if (!angular.isArray(injects)) {
                    injects = [injects];
                }
                var key = urls.join('.');
                if ( injected[key] ) {
                    callback && callback(injected[key]);
                } else {
                    this.urls(urls, function(){
                        $injector.invoke(injects);
                    });
                }
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('List', ['Flat', 'Listitem', function (Flat, Listitem) {
        var _class = {
            list:'list',
            item:'list-item',
            checked:'checked',
            actived:'active',
            head:'list-head',
            checker:'checker'
        };
        function list(scope, datakey, xExtends) {
            var that = this;
            angular.extend(this, xExtends);
            this.scope = scope;
            this.datakey = datakey;
            var _apply = function(){
                if (!scope.$$phase) scope.$apply();
            };
            this.preAppend = function(data){
                Flat.unshift(scope, datakey, data); _apply();
                return this;
            };
            this.append = function(data) {
                Flat.push(scope, datakey, data); _apply();
                return this;
            };
            this.push = function(data) {
                return this.append(data);
            };
            this.pop = function() {
                Flat.pop(scope, datakey); _apply();
                return this;
            };
            this.count = function(){
                var data = Flat.get(scope, datakey);
                return data ? data.length : 0;
            };
            this.data = function(data) {
                if (data === undefined) {
                    return Flat.get(scope, datakey);
                } else {
                    if (angular.isString(data)) {
                        data = angular.fromJson(data);
                    }
                    data = data || [];
                    Flat.set(scope, datakey, data); _apply();
                    return that;
                }
            };
            this.setLength = function(length) {
                Flat.cut(scope, datakey, length);
            };
            this.mapIndex = function(ids){
                var _list = {};
                var data = that.data();
                if (!data) return -1;
                data.forEach(function(item, index){
                    _list[item.id] = index;
                });
                if (angular.isArray(ids)) {
                    var ret = [];
                    angular.forEach(ids, function(id){
                        ret.push(_list[id]);
                    });
                    return ret;
                } else {
                    return _list[ids];
                }
            };
            this.mapId = function(index){
                var _list = {};
                return this.data(index, 'id');
            };
            this.clear = function(){
                Flat.set(scope, datakey, []); _apply();
            };
            this.item = {
                make:function($event) {
                    return Listitem.make(that, $event);
                },
                get:function($event){
                    return this.make($event).get();
                },
                getlist:function($xvar) {
                    return this.make($event).getlist();
                },
                swap:function(index1, index2){
                    var data1 = this.data(index1);
                    var data2 = this.data(index2);
                    var data = that.data();
                    data[index1] = data2;
                    data[index2] = data1;
                    return data;
                },
                index:function($xvar){
                    if (!angular.isNumber($xvar)) {
                        return this.make($xvar).index();
                    } else {
                        return $xvar;
                    }
                },
                data:function($xvar, data_or_key) {
                    var index = this.index($xvar);
                     return Listitem.data(scope, datakey, index, data_or_key);
                },
                update:function($xvar, data, field){
                    var index = this.index($xvar);
                    Listitem.update(scope, datakey, index, data, field);
                    return this;
                },
                remove:function($xvar) {
                    var index = this.index($xvar);
                    Listitem.remove(scope, datakey, index);
                    return that;
                },
                active:function($event, is_active){
                    return this.make($event).active(is_active);
                },
                select:function($event, is_select){
                    return this.make($event).select(is_select);
                }
            };
        }
        return {
            make:function(scope, datakey, initData, extendsMethod){
                if (initData === undefined) initData = [];
                if (!Flat.get(scope, datakey) && initData) {
                    Flat.set(scope, datakey, initData);
                }
                return new list(scope, datakey, extendsMethod);
            },
            _class:_class
        };
    }]);
;angular.module('Landers.angular')
    .factory('Listitem', ['Flat', function (Flat){
        var _class = {
            list:'list',
            item:'list-item',
            checked:'checked',
            actived:'active',
            head:'list-head',
            checker:'checker'
        };
        var data = function(scope, datakey, index, data_or_key){
            if (typeof data_or_key === 'undefined') {
                return Flat.get(scope, [datakey, index].join('.'));
            } else {
                if (angular.isString(data_or_key)) {
                    var dat = Flat.get(scope, [datakey, index].join('.')) || {};
                    return dat[data_or_key];
                } else {
                    Flat.set(scope, [datakey, index].join('.'), data);
                }
            }
        };
        var update = function(scope, datakey, index, data, field) {
            var _update = function(_field, _data){
                var _datakey = [datakey, index, _field];
                Flat.set(scope, _datakey.join('.'), _data);
            };
            if (field) {
                _update(field, data);
            } else {
                for (var fieldKey in data){
                    _update(fieldKey, data[fieldKey]);
                }
            }
            if (!scope.$$phase) scope.$apply();
        };
        var remove = function(scope, datakey, index){
            if ( index >= 0) {
                var data = Flat.get(scope, datakey);
                data.splice(index, 1);
                if (!scope.$$phase) scope.$apply();
            }
        };
        function Listitem(lister, $event) {
            var $item = (function(){
                if (angular.isElement($event)) {
                    return $event;
                } else {
                    $event = angular.element($event.target);
                    return $event.closest('.' + _class.item);
                }
            })();
            this.get = function(){
                return $item;
            };
            this.getlist = function() {
                return $item.closest('.' + _class.list);
            };
            this.index = function(){
                var $head = $item.siblings('.' + _class.head);
                var index = $item.index();
                return $head.length ? index - 1 : index;
            };
            this.data = function(data_or_key) {
                var index = this.index();
                return data(lister.scope, lister.datakey, index, data_or_key);
            };
            this.update = function(data, field){
                var index = this.index();
                update(lister.scope, lister.datakey, index, data, field);
            };
            this.remove = function() {
                var index = this.index();
                remove(lister.scope, lister.datakey, index);
            };
            this.toggleClass = function(is, classname){
                if (is) {
                    $item.addClass(classname);
                } else {
                    $item.removeClass(classname);
                }
                return this;
            };
            this.active = function(is_active){
                return this.toggleClass(is_active, _class.actived);
            };
            this.select = function(is_check){
                return this.toggleClass(is_check, _class.checked);
            };
        }
        return {
            make:function(lister, $event) {
                return new Listitem(lister, $event);
            },
            _class:_class,
            data:data,
            update:update,
            remove:remove
        };
    }]);
;angular.module('Landers.angular')
    .factory('Location', ['$location', function($location){
        return {
            param:function(index, noNull){
                var url = $location.url().split('/');
                if (index == 'last') index = url.length - 1;
                var ret = url[index];
                if (!ret && noNull !== false) {
                    ret = url[index-1];
                }
                return ret;
            },
            params:function(keys){
                var url = $location.url().split('/');
                var ret = {};
                angular.forEach(keys, function(item, i){
                    ret[item] = url[i+2];
                });
                return ret;
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('Runtime', ['Flat', function (Flat) {
        var cache = {};
        function runtime (scope){
            if ( !cache[scope.$id] ) {
                scope.$runtime = {};
                cache[scope.$id] = true;
            }
            this.__proto__ = Flat.make(scope, scope.$runtime);
        }
        return {
            make:function(scope){
                return new runtime(scope);
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('TabIndex', ['$state', 'Location', function ($state, Location){
        function TabIndex(scope) {
            this.show = function(callbacks){
                var that = this;
                var stateData = $state.$current.data || {};
                var tab_index = typeof stateData.tabIndex !== 'undefined' ?
                                stateData.tabIndex : Location.param(2);
                scope.tabIndex = tab_index;
                var _callback = callbacks[tab_index] || callbacks['default'];
                if (_callback) _callback(tab_index);
                else throw('callbacks[' + tab_index + ']未定义');
            };

        }
        return {
            make:function(_scope){return new TabIndex(_scope);},
            get:function(){return Location.param(2);}
        };
    }]);
;angular.module('Landers.angular')
    .filter('datetime', ['$filter', function($filter){
        return function(input, format) {
            if ( !input ) return;
            var str = typeof(input) == 'number' ? $filter("date")(input * 1000, 'yyyy-MM-dd HH:mm:ss') : input;
            var a = str.split(' ');
            switch (format) {
                case 'date' : return a[0];
                case 'time' : return a[1];
                default : return str;
            }
        };
    }]);
;angular.module('Landers.angular')
    .filter('nl2br', function(){
        return function(str) {
            var s1 = '\n'; s2 = '<br/>';
            s1 = s1.replace(/\{/,'\\{').replace(/\}/,'\\}');
            var re = new RegExp(s1,"gi");
            return str.replace(re,s2);
        };
    });
;angular.module('Landers.angular')
    .filter('nl2li', function(){
        return function(str) {
            return (str || '').split('\n').map(function(line){
                return '<li>' + line + '</li>';
            }).join('');
        };
    });
;angular.module('Landers.angular')
    .filter('round', function() {
        return function(num, n){return Math.round(num*Math.pow(10,n || 0))/Math.pow(10,n || 0); };
    });
;angular.module('Landers.angular')
    .provider('Ajax', function() {
        var provider = this;
        this.hosturl = '';
        this.$get = ['$http', '$rootScope', '$q', function($http, $rootScope, $q){
            var csrf_token;
            function Ajax() {
                var _debug, _loading;
                var _hosturl = provider.hosturl;
                var cancellers = [];
                var prevents = {
                    error : false,
                    error_once : false
                };
                var build_url = function(url, params) {
                    if (params) {
                        url = Landers.url.qs.set(url, params);
                    }
                    return _hosturl + url;
                };
                this.setHosturl = function(hosturl){
                    _hosturl = hosturl;
                    return this;
                }
                this.debug = function(is){
                    _debug = is !== false && is !== 0;
                    return this;
                };
                this.loading = function(is){
                    _loading = is === true || is === undefined;
                    return this;
                };
                this._get = function(method, url, params){
                    var that = this;
                    url = build_url(url, params);
                    if (_debug) {
                        return Landers.ajax.debug().get(url);
                    } else {
                        var ret, config = {ignoreLoadingBar: !_loading};
                        var canceler = $q.defer();
                        cancellers.push(canceler);
                        // 添加timeout设置为promise对象，才可以取消未完成的request请求
                        config.timeout = canceler.promise;
                        switch (method.toLowerCase()) {
                            case 'get' :
                                ret = $http.get(url, config); break;
                            case 'delete':
                                ret = $http.delete(url, config); break;
                        }
                        ret.success(that.success).error(that.error)
                           .finally(function(){cancellers.pop();});
                        _loading = _debug = false;
                        return ret;
                    }
                };
                this.get = function(url, params) {
                    return this._get('get', url, params);
                };
                this.delete = function(url, params){
                    return this._get('delete', url, params);
                };
                this._post = function(method, url, xvar, params){
                    var that = this;
                    url = build_url(url, params);
                    // var data = angular.isString(xvar) || angular.isElement(xvar) ? Form.data(xvar) : xvar;
                    var data = xvar || {};

                    if (csrf_token) data._token = csrf_token;
                    if (_debug) {
                        return Landers.ajax.debug().post( url, data );
                    } else {
                        var ret, config = {ignoreLoadingBar: !_loading}; //, withCredentials:true
                        var canceler = $q.defer();
                        cancellers.push(canceler);
                        // 添加timeout设置为promise对象，才可以取消未完成的request请求
                        config.timeout = canceler.promise;
                        switch (method.toLowerCase()) {
                            case 'post' :
                                ret = $http.post(url, data, config); break;
                            case 'put' :
                                data['_method'] = 'put';
                                ret = $http.put(url, data, config); break;
                        }
                        ret.success(that.success).error(that.error)
                           .finally(function(){cancellers.pop();});

                        _loading = _debug = false;
                        return ret;
                    }
                };
                this.post = function(url, xvar, params){
                    return this._post('post', url, xvar, params);
                };
                this.put = function(url, data, params){
                    return this._post('put', url, data, params);
                };
                this.success = function(rspn, code, header){
                    csrf_token = rspn.csrf_token;
                    if (rspn.code == 1 && rspn.message) {
                        Landers.msgbox(rspn);
                    }
                };
                this.error = function(rspn) {
                    if (angular.isObject(rspn)) {
                        csrf_token = rspn.csrf_token || csrf_token;
                    } else {
                        console.log('无响应404');
                        rspn = {
                            success : false,
                            message : '' //'远程无响应或OPTION方法',
                        };
                    }
                };
                this.cancelAll = function(i){
                    if ( cancellers.length ) {
                        var canceller;
                        while (canceller = cancellers.pop()) {
                            canceller.resolve("user cancelled");
                        }
                    }
                };
            }
            return {
                make:function(){
                    return new Ajax();
                },
                csrf_token:function(){
                    return csrf_token;
                }
            };
        }];
    });
;angular.module('Landers.angular')
    .provider('Dialog', function(){
        var provider = this;
        this.skin = 'ulan';
        this.defaults = {
            effect : 'random'
        };
        this.$get = ['$compile', '$timeout', function($compile, $timeout) {

            //先异步加载css文件，以便Landers.dialog.show为非异步
            Landers.dialog.loadmod(provider.skin);
            return {
                confirm:function(scope, opts, callbacks){
                    angular.extend(opts, {
                        top : '30%',
                        yes: {text:'　确定　', fn:callbacks.yesFn },
                        no: {text:'　取消　', fn:callbacks.noFn },
                        angular : {compile:$compile, scope:scope, timeout:$timeout}
                    });
                    return Landers.dialog.show(opts);
                },
                show:function(scope, opts){
                    var extOpts = opts.compile === false ? {} : {
                        angular : {compile:$compile, scope:scope, timeout:$timeout},
                    };

                    opts = angular.extend({}, provider.defaults, extOpts, opts);
                    return Landers.dialog.show(opts, provider.skin);
                }
            };
        }];
    });
;angular.module('Landers.angular')
    .factory('RouteMenu', ['$state', function($state){
            function RouteMenu( selector ){
                var that = this;

                this.getMenu = function( callback ){
                    var $menu = $(selector);

                    if ( !$menu.length || !$menu.children().length) {
                        var self = arguments.callee;
                        setTimeout(function(){
                            self(callback);
                        }, 300);
                    } else {
                        callback && callback( $menu );
                    }

                    return that;
                };

                this.findForActive = function(callback){
                    var active_states = $state.current.activeStates;
                    if ( !active_states || !active_states.length ) {
                        active_states = [ $state.current.name ];
                    }

                    that.getMenu( function( $menu ){
                        angular.forEach(active_states, function(state){
                            var $o = $menu.find("[ui-sref^='" + state + "(']");
                            callback && callback( $o );
                        });
                    });

                    return that;
                }
            }

            return {
                make: function(selector){
                    return new RouteMenu(selector);
                }
            }
        }]);
;angular.module('Landers.angular')
    .directive('listStatus', ['$templateRequest', '$compile', 'Flat', 'Helpers', '$timeout', function($templateRequest, $compile, Flat, Helpers, $timeout){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                $ele.addClass('list-status');
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var modelKey = $attrs['modelKey'], html = '';
                var datakey1 = [modelKey, '$list', 'data'].join('.');
                var icon1 = '<i class="glyphicon glyphicon-remove-sign"></i> ';
                var icon2 = '<i class="glyphicon glyphicon-info-sign"></i>';

                myScope.$watch(datakey1, function(newValue){
                    var html;
                    if (newValue) {
                        if ( !newValue.length ) {
                            var datakey2 = [modelKey, '$errors.$list'].join('.');
                            var error_message = Flat.get(myScope, datakey2);
                            if ( !error_message ) {
                                datakey3 = [modelKey, '$search'].join('.');
                                var htmlTpl = '<div class="alert alert-warning pv20">%s</div>';
                                var datakey4 = [modelKey, '$name'].join('.');
                                var appname = Flat.get(myScope, datakey4);

                                var searchData = Flat.get(myScope, datakey3);
                                if ( searchData && Landers.utils.json.count(searchData) ) {
                                    html = icon1 + ' 没有检索到符合条件的' + appname + '。您可以尝试其他搜索条件或<a class="highlight hand" ng-click="' + modelKey + '.$event.resetSearch()">重置搜索</a> ';
                                    html = Landers.utils.str.sprintf(htmlTpl, html);
                                } else {
                                    var partial = $attrs['partialNone'];
                                    var message = $attrs['messageNone'];
                                    if (partial) {
                                        var partial_url = myScope.$partial(partial);
                                        $templateRequest(partial_url).then(function(html){
                                            html = Landers.utils.str.sprintf(htmlTpl, html);
                                            $ele.fadeOut(300, function(){
                                                var compile = $compile(html)(myScope);
                                                $timeout(function(){
                                                    $ele.html(compile).fadeIn(300);
                                                }, 100);
                                            });
                                        });
                                        return;

                                    } else if (message) {
                                        html = message;
                                    } else {
                                        html = '暂无' + appname + '。';
                                    }
                                    html = Landers.utils.str.sprintf(htmlTpl, icon1 + html);
                                }
                            } else {
                                html = '<div class="alert alert-danger pv20">' + icon2 + ' ' + error_message + ' </div>';
                            }
                            $ele.fadeOut(300, function(){
                                $ele.html($compile(html)(myScope)).fadeIn(300);
                            });
                        } else {
                            $ele.text('').stop(true).fadeOut(300);
                        }
                    } else {
                        html = '<div class="alert alert-default pv20"><i class="glyphicon glyphicon-cog glyphicon-spin fa fa-cog fa-spin"></i> loading... </div>';
                        $ele.html($compile(html)(myScope)).hide().fadeIn(500);
                    }
                }, true);
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('uiAlertError', ['Flat', function(Flat){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var datKey = $attrs['uiAlertError'];
                $ele.addClass('alert alert-danger').hide();
                $scope.$watch(datKey, function(newValue){
                    if (newValue) {
                        var html = '<i class="fa fa-minus-circle"></i> ' + newValue;
                        $ele.html(html).show();
                    } else {
                        $ele.hide();
                    }
                });
                var $form = $ele.closest('form');
                $form.find('input, select, textarea').change(function(){
                    var ele = $(this);
                    if (!ele.val()) return;
                    var ngmodel = ele.attr('ng-model');
                    var arr = ngmodel.split('.');
                    arr.splice(1, 0, '$errors');
                    var datkey = arr.join('.');
                    Flat.set($scope, datkey, '');
                    if (!$scope.$$phase) $scope.$apply();
                });
            }
        };
    }])
;angular.module('Landers.angular')
    .directive('checklistModel', ['$parse', '$compile', function($parse, $compile) {
        // contains
        function contains(arr, item, comparator) {
            if (angular.isArray(arr)) {
                for (var i = arr.length; i--;) {
                    if (comparator(arr[i], item)) {
                        return true;
                    }
                }
            }
            return false;
        }

        // add
        function add(arr, item, comparator) {
            arr = angular.isArray(arr) ? arr : [];
            if (!contains(arr, item, comparator)) {
                arr.push(item);
            }
            return arr;
        }

        // remove
        function remove(arr, item, comparator) {
            if (angular.isArray(arr)) {
                for (var i = arr.length; i--;) {
                    if (comparator(arr[i], item)) {
                        arr.splice(i, 1);
                        break;
                    }
                }
            }
            return arr;
        }

        // http://stackoverflow.com/a/19228302/1458162
        function postLinkFn(scope, elem, attrs) {
            // exclude recursion, but still keep the model
            var checklistModel = attrs.checklistModel;
            attrs.$set("checklistModel", null);
            // compile with `ng-model` pointing to `checked`
            $compile(elem)(scope);
            attrs.$set("checklistModel", checklistModel);

            // getter for original model
            var checklistModelGetter = $parse(checklistModel);
            var checklistChange = $parse(attrs.checklistChange);
            var checklistBeforeChange = $parse(attrs.checklistBeforeChange);
            var ngModelGetter = $parse(attrs.ngModel);



            var comparator = angular.equals;

            if (attrs.hasOwnProperty('checklistComparator')) {
                if (attrs.checklistComparator[0] == '.') {
                    var comparatorExpression = attrs.checklistComparator.substring(1);
                    comparator = function(a, b) {
                        return a[comparatorExpression] === b[comparatorExpression];
                    };

                } else {
                    comparator = $parse(attrs.checklistComparator)(scope.$parent);
                }
            }

            // watch UI checked change
            scope.$watch(attrs.ngModel, function(newValue, oldValue) {
                if (newValue === oldValue) {
                    return;
                }

                if (checklistBeforeChange && (checklistBeforeChange(scope) === false)) {
                    ngModelGetter.assign(scope, contains(checklistModelGetter(scope.$parent), getChecklistValue(), comparator));
                    return;
                }

                setValueInChecklistModel(getChecklistValue(), newValue);

                if (checklistChange) {
                    checklistChange(scope);
                }
            });

            // watches for value change of checklistValue (Credit to @blingerson)
            scope.$watch(getChecklistValue, function(newValue, oldValue) {
                if (newValue != oldValue && angular.isDefined(oldValue) && scope[attrs.ngModel] === true) {
                    var current = checklistModelGetter(scope.$parent);
                    checklistModelGetter.assign(scope.$parent, remove(current, oldValue, comparator));
                    checklistModelGetter.assign(scope.$parent, add(current, newValue, comparator));
                }
            });

            function getChecklistValue() {
                return attrs.checklistValue ? $parse(attrs.checklistValue)(scope.$parent) : attrs.value;
            }

            function setValueInChecklistModel(value, checked) {
                var current = checklistModelGetter(scope.$parent);
                if (angular.isFunction(checklistModelGetter.assign)) {
                    if (checked === true) {
                        checklistModelGetter.assign(scope.$parent, add(current, value, comparator));
                    } else {
                        checklistModelGetter.assign(scope.$parent, remove(current, value, comparator));
                    }
                }

            }

            // declare one function to be used for both $watch functions
            function setChecked(newArr, oldArr) {
                if (checklistBeforeChange && (checklistBeforeChange(scope) === false)) {
                    setValueInChecklistModel(getChecklistValue(), ngModelGetter(scope));
                    return;
                }
                ngModelGetter.assign(scope, contains(newArr, getChecklistValue(), comparator));
            }

            // watch original model change
            // use the faster $watchCollection method if it's available
            if (angular.isFunction(scope.$parent.$watchCollection)) {
                scope.$parent.$watchCollection(checklistModel, setChecked);
            } else {
                scope.$parent.$watch(checklistModel, setChecked, true);
            }
        }

        return {
            restrict: 'A',
            priority: 1000,
            terminal: true,
            scope: true,
            compile: function(tElement, tAttrs) {

                if (!tAttrs.checklistValue && !tAttrs.value) {
                    throw 'You should provide `value` or `checklist-value`.';
                }

                // by default ngModel is 'checked', so we set it if not specified
                if (!tAttrs.ngModel) {
                    // local scope var storing individual checkbox model
                    tAttrs.$set("ngModel", "checked");
                }

                return postLinkFn;
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('bool', ['Flat', function(Flat){
        return {
            restrict : 'AE',
            require : 'ngModel',
            template : '<span class="label label-success">是</span><span class="label label-warning">否</span>',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                var $childs = $ele.children();
                $scope.$watch(ngModel, function(new_value){
                    var bool = !!~~new_value;
                    if (bool) {
                        $childs.eq(0).show();
                        $childs.eq(1).hide();
                    } else {
                        $childs.eq(0).hide();
                        $childs.eq(1).show();
                    }
                });

            }
        }
    }]);
;angular.module('Landers.angular')
    .directive('bootstrapTooltip', [function(){
        return {
            restrict : 'C',
            link : function($scope, $ele, $attrs){
                (function(){
                    var self = arguments.callee;
                    var title = $ele.attr('data-title');
                    if ( !title || title.match(/\{\{(.*)\}\}/) ) {
                        setTimeout(self, 300);
                    } else {
                        $ele.tooltip();
                    }
                })();
            }
        }
    }]);
;angular.module('Landers.angular')
    .factory('DatatimePickerHelper', ['Flat', '$timeout', function(Flat, $timeout){
        function DatatimePickerHelper(scope, ngModel, $begin, $end) {
            var ngModelBegin = $begin.attr('ng-model');
            var ngModelEnd = $end.attr('ng-model');
            this.set = function(begin, end){
                $timeout(function(){
                    begin = begin || '';
                    end = end || '';
                    if (ngModelBegin) {
                        Flat.set(scope, ngModelBegin, begin);
                    } else {
                        $begin.val(begin);
                    }
                    if (ngModelEnd) {
                        Flat.set(scope, ngModelEnd, end);
                    } else {
                        $end.val(end);
                    }
                    if (ngModel) {
                        Flat.set(scope, ngModel, begin || end ? [begin, end] : undefined);
                    }
                    if (ngModelBegin || ngModelEnd || ngModel) scope.$apply();
                }, 100);
            };
        }

        return {
            make : function(scope, ngModel, $begin, $end){
                return new DatatimePickerHelper(scope, ngModel, $begin, $end);
            },
            locale : {
                'zh-cn' : {
                    today : '定位今天',
                    clear : '清空',
                    close : '关闭',
                    selectMonth: '选择月份',
                    prevMonth: '上月',
                    nextMonth: '下月',
                    selectYear: '选择年份',
                    prevYear: '上年',
                    nextYear: '下年',
                    selectDecade: 'Select Decade',
                    prevDecade: 'Previous Decade',
                    nextDecade: 'Next Decade',
                    prevCentury: 'Previous Century',
                    nextCentury: 'Next Century',
                    pickHour: '选取小时',
                    incrementHour: '增加小时',
                    decrementHour: '减少小时',
                    pickMinute: '选取分钟',
                    incrementMinute: '增加分钟',
                    decrementMinute: '减少分钟',
                    pickSecond: '选取秒',
                    incrementSecond: '增加秒',
                    decrementSecond: '减少秒',
                    togglePeriod: 'Toggle Period',
                    selectTime: '选择时间'
                }
            }
        };
    }])
    .directive('bootstrapDatetimeRangePicker', ['Flat', '$timeout', 'DatatimePickerHelper', function(Flat, $timeout, DatatimePickerHelper){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                var $begin = $ele.siblings('.datetime-begin');
                var $end = $ele.siblings('.datetime-end');
                var helper = DatatimePickerHelper.make($scope, ngModel, $begin, $end);

                var format = $ele.data('format') || 'YYYY-MM-DD hh:mm A';

                var defaults = {
                    showISOWeekNumbers: true,
                    timePicker24Hour: true,
                    alwaysShowCalendars: true,
                    opens: 'left',
                    timePicker: true,
                    timePickerIncrement: 1,
                    locale: {
                        format: format,
                        cancelLabel: 'Clear'
                    }
                };
                var config = $ele.data();
                delete config.$ngModelController;
                config = angular.extend({}, defaults, config);

                $ele.daterangepicker(config, function(begin, end, label) {
                    begin = begin.format(config.format);
                    end = end.format(config.format);
                    helper.set(begin, end);
                });

                $ele.on('cancel.daterangepicker', function(ev, picker) {
                    $ele.val('');
                });
                $ele.val('');
            }
        };
    }])
    .directive('bootstrapDatetimePicker', ['Flat', '$timeout', 'DatatimePickerHelper', function(Flat, $timeout, DatatimePickerHelper){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var ngModel = $attrs['ngModel'];
                $ele.addClass('datetime-picker');
                var $begin = $ele.children('.datetime-begin');
                var $end = $ele.children('.datetime-end');
                var helper = DatatimePickerHelper.make($scope, ngModel, $begin, $end);

                var defaults = {
                    format : 'YYYY-MM-DD HH:mm:ss',
                    showClose:true,
                    showClear:true,
                    sideBySide:false,
                    showTodayButton: true,
                    locale: 'zh-cn',
                    tooltips:DatatimePickerHelper.locale['zh-cn']
                };
                var config = $ele.data();
                delete config.$ngModelController;
                delete config.minDate;
                delete config.maxDate;
                config = angular.extend({}, defaults, config);

                $begin.add($end).datetimepicker(config);

                var values = {begin:'', end:''};
                $begin.on('dp.change', function(e){
                    if ( e.date) {
                        values.begin = e.date.format(config.format);
                    } else {
                        values.begin = '';
                    }
                    helper.set(values.begin, values.end);
                });
                $end.on('dp.change', function(e){
                    if ( e.date ) {
                        values.end = e.date.format(config.format);
                    } else {
                        values.end = '';
                    }
                    helper.set(values.begin, values.end);
                });
                $begin.add($end).on('dp.show', function(){
                    var $wrapper = $(this).next();
                    var dtp = $(this).data('DateTimePicker');
                    var minDate = $(this).data('minDate');
                    if (minDate) dtp.minDate(minDate);
                    var maxDate = $(this).data('maxDate');
                    if (maxDate) dtp.maxDate(maxDate);

                    setTimeout(function(){
                        $wrapper.find('.timepicker-picker a.btn').removeClass('btn');
                    }, 200);
                });
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('disabledWhen', ['$compile', 'Runtime', 'Helpers', function($compile, Runtime, Helpers){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var datkey = $attrs['disabledWhen'];
                var runtime = Runtime.make(myScope);
                var cache = runtime.get('watchers') || {};

                if ( cache[datkey] ) {
                    cache[datkey].push($ele);
                    runtime.set('watchers', cache);
                } else {
                    cache[datkey] = [$ele];
                    runtime.set('watchers', cache);
                }

                myScope.$watch(datkey, function(newValue){
                    cache[datkey].map(function($e){
                        if (newValue) $e.addClass('disabled').prop('disabled', true);
                        else $e.removeClass('disabled').prop('disabled', false);
                    });
                });
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('icheck', ['$timeout', '$parse', function ($timeout, $parse) {
        return {
            require: 'ngModel',
            link: function($scope, element, $attrs, ngModel) {

                return $timeout(function() {
                    var value;
                    value = $attrs['value'];

                    $scope.$watch($attrs['ngModel'], function(newValue){
                        $(element).icheck('update');
                    });

                    Landers.loader.jsm('jquery.icheck,true', function(){
                        return $(element).icheck({
                            checkboxClass: 'icheckbox_square-blue',
                            radioClass: 'iradio_square-blue'

                        }).on('ifChanged', function(event) {
                            if ($(element).attr('type') === 'checkbox' && $attrs['ngModel']) {
                                $scope.$apply(function() {
                                    return ngModel.$setViewValue(event.target.checked);
                                });
                            }
                            if ($(element).attr('type') === 'radio' && $attrs['ngModel']) {
                                return $scope.$apply(function() {
                                    return ngModel.$setViewValue(value);
                                });
                            }
                        });
                    });

                });
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('pagebar', ['$compile', 'Flat', function($compile, Flat){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var modelKey = $attrs['modelKey'];
                var pageinfo = Landers.utils.to.bool($attrs['pageinfo']);
                $scope.$watch (modelKey + '.$list', function($list){
                    if ( !$list ) return;

                    var current, total, size, last;
                    if ( $list.page ) {
                        current = '%M%.$list.page.current';
                        total = '%M%.$list.page.total';
                        size = '%M%.$list.page.size';
                        last = '%M%.$list.page.last';
                    } else {
                        current = '%M%.$list.current_page';
                        total = '%M%.$list.total';
                        size = '%M%.$list.per_page';
                        last = '%M%.$list.last_page';
                    }
                    var html = '', paging_action = $attrs['pagingAction'] || '%M%.$event.showPage(page)';
                    html += '<div ng-if="' + last + ' > 1 && ' + total + ' > 1 && ' + size + ' > 1 &&' + last + ' > 1 ">';
                    if (pageinfo) {
                        html += '<div class="fl page-info">';
                        html += '   <ul class="hlist pageinfo">';
                        html += '       <li>页次：{{' + current + '}}/{{' + last + '}}</li>';
                        html += '       <li class="ml15">每页：{{' + size + '}}</li>';
                        html += '       <li class="ml15">总数：{{' + total + '}}</li>';
                        html += '       <li class="ml15" ng-show="%M%.$items.selected.length">选中: {{%M%.$items.selected.length}}</li>';
                        html += '   </ul>';
                        html += '</div>';
                        html += '<div class="fr">';
                        html += '   <div class="page-num paging" paging page="' + current + '" page-size="' + size + '" total="' + total + '" paging-action="' + paging_action + '" transclude="true"></div>';
                        html += '</div>';
                    } else {
                        html += '<div paging class="page-num paging text-center" page="' + current + '" page-size="' + size + '" total="' + total + '" paging-action="' + paging_action + '" transclude="true"></div>';
                    }
                    html += '</div>';
                    html = html.replace(/%M%/g, modelKey);
                    $ele.html($compile(html)($scope));
                });
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('protip', [function(){
        if ( !$.protip ) Landers.loader.jsm('jquery.protip,true');
        var is_protip = false;
        return {
            restrict : 'C',
            link : function($scope, $ele, $attrs){
                var self = arguments.callee;
                if ( !$ele.attr('data-pt-size') ) {
                    $ele.attr('data-pt-size', 'small');
                }
                if ( !$ele.attr('data-pt-scheme') ) {
                    $ele.attr('data-pt-scheme', 'black');
                }

                if ($.protip && $ele.attr('data-pt-title')) {
                    $.protip();
                    $ele.on('protipshow', function(itemInstance){
                        var $me = $(itemInstance.target);
                        var t = $me.data('ptShow');
                        if (t !== undefined && t !== true) {
                            setTimeout(function(){
                                $me.protipHide();
                            }, 5);
                        }
                    });
                } else {
                    setTimeout(function(){
                        self($scope, $ele, $attrs);
                    }, 500);
                }
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('remedySelect', function() {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                var allow_mouseout = true;
                var blur_click = function(){
                    allow_mouseout = false;
                    setTimeout(function(){allow_mouseout = true;}, 100);
                };
                $element.mouseover(function(){
                    $(this).addClass('onhover');
                })
                .mouseout(function(){
                    if (allow_mouseout) {
                        $(this).removeClass('onhover onfocus');
                    }
                })
                .blur(function(){
                    blur_click();
                    $(this).removeClass('onhover onfocus');
                })
                .click(function(){
                    blur_click();
                    $(this).addClass('onfocus').removeClass('onhover');
                });
            }
        };
    });
;angular.module('Landers.angular')
    .directive('landersNameValueInputer', function($compile, Flat, Dialog, List) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                var model_key = $attrs['nviModel'];
                var view_key = $attrs['nviView'];

                var html = '';
                html += '<div class="relative">';
                html += '   <a ng-click="landersNameValuesAdd($event)" class="btn btn-sm btn-primary absolute right-top"><i class="glyphicon glyphicon-plus"></i></a>';
                html += '</div>';
                html += '<ul class="hlist list">';
                html += '    <li ng-repeat="item in ' + view_key + '" class="mr20 mb5 list-item">';
                html += '        <span class="">{{item.name}}：{{item.value}}</span>';
                html += '        <a ng-click="landersNameValuesRemove($event)" class="btn btn-warning btn-xs ml5"><i class="glyphicon glyphicon-minus"></i></a>';
                html += '    </li>';
                html += '</ul>';
                html += '<input ng-model="' + model_key + '" type="hidden"/>';

                var el = $compile(html)($scope);
                $element.css({height:'100%'}).append(el);
                if (!$scope.$$phase) $scope.$apply();
                $element.find('.list').css({'margin-right':$element.find('.btn').width() + 20 })

                var lister = List.make($scope, view_key).data([]);
                $scope.$watch(model_key, function(model){
                    if (model) lister.data(model);
                });

                var html = '';
                html += '<form class="form-horizontal">';
                html += '   <table cellpadding="0" cellspacing="0" border="0" class="stereo form-table">';
                html += '   <tr>';
                html += '       <td><label class="control-label">名称</label></td>';
                html += '       <td><div class="control-input"><input ng-model="$runtime.nvi.name" maxlength="30" value="" type="text" class="form-control"/></div></td>';
                html += '   </tr>';
                html += '   <tr>';
                html += '       <td><label class="control-label">数据</label></td>';
                html += '       <td><div class="control-input"><textarea ng-model="$runtime.nvi.value" value="" type="text" class="form-control"></textarea></div></td>';
                html += '   </tr>';
                html += '   </table>';
                html += '</form>';
                angular.extend($scope, {
                    landersNameValuesAdd : function(){
                        Flat.set($scope, '$runtime.nvi', {});
                        setTimeout(function(){
                            Dialog.show($scope, {
                                title   : $attrs['nviName'],
                                content : html,
                                width   : 350,
                                lock    : true,
                                fixed   : true,
                                effect  : 'vmove1',
                                onload  : function(){
                                },
                                yes     : function(){
                                    var nvi = Flat.get($scope, '$runtime.nvi');
                                    lister.append(angular.extend({}, nvi));
                                    Flat.set($scope, model_key, angular.toJson(lister.data()));
                                },
                                no      : true
                            });
                        }, 200);
                    },
                    landersNameValuesRemove : function($event){
                        lister.item.remove($event);
                        Flat.set($scope, model_key, angular.toJson(lister.data()));
                    }
                })
            }
        }
    });
;angular.module('Landers.angular')
    .directive('dropSelect', ['Flat', function(Flat) {
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var $button = $ele.find('.dropdown-toggle');
                var $list = $ele.find('.dropdown-menu');

                var init_event = $attrs['dropSelectInit'];
                init_event = Flat.get($scope, init_event);
                if (init_event) init_event();

                var change_event = $attrs['dropSelectChange'];
                change_event = Flat.get($scope, change_event);
                if (change_event) {
                    (function(){
                        var self = arguments.callee;
                        var $items = $list.children('li');
                        if ($items.length) {
                            $items.on('click', function(){
                                change_event($(this));
                            });
                        } else {
                            setTimeout(self, 300);
                        }
                    })();
                }
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('includeReplace', function () {
        return {
            require: 'ngInclude',
            restrict: 'A', /* optional */
            link: function (scope, el, attrs) {
                el.replaceWith(el.children());
            }
        };
    })
;angular.module('Landers.angular')
    .directive('mCustomerScroll', [function(){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                setTimeout(function(){
                    $ele.mCustomScrollbar({
                        autoHideScrollbar:true,
                        scrollInertia:550,
                        theme:'minimal-dark',
                        preventDefault:true,
                        mouseWheel:true
                    });
                }, 300);
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('iscroll', [function(){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                $ele.css({overflow:'hidden'});

                var options = $attrs['iscrollOption'] || '{}';
                options = angular.fromJson(options) || {};
                options = angular.extend({
                    scrollbars: true,
                    mouseWheel: true,
                    click: true
                }, options);

                var styles = $attrs['iscrollStyle'];
                var $wraper = $ele.children(':eq(0)');

                (function(){
                    var self = arguments.callee;
                    if ($wraper.children().length) {
                        new IScroll($ele.get(0), options);
                        setTimeout(function(){
                            $ele.find('.iScrollIndicator').css({
                                border: 'none',
                                width: '4px',
                                right: '0px'
                            }).get(0).style.cssText += styles;
                        }, 100);
                    } else {
                        setTimeout(self, 300);
                    }
                })();
            }
        };
    }]);
;angular.module('Landers.angular')
    .factory('AngularApi', ['$httpParamSerializer', 'Ajax', function ($httpParamSerializer, Ajax) {
        var url_styles = {
            restful : {
                index: '{apiurl}?page={page}&pagesize={pagesize}',
                create: '{apiurl}/create',
                store: '{apiurl}',
                show: '{apiurl}/{id}',
                edit: '{apiurl}/{id}/edit',
                update: '{apiurl}/{id}',
                delete: '{apiurl}/{id}',
                opposite: '{apiurl}/opposite/{id}/{prop}',
                custom : '{apiurl}/{action}'
            },
            parallelism : {
                index: '{apiurl}/list?page={page}&pagesize={pagesize}',
                create: '{apiurl}/create',
                store: '{apiurl}/create',
                show: '{apiurl}/show?id={id}',
                edit: '{apiurl}/edit?id={id}',
                update: '{apiurl}/update?id={id}',
                delete: '{apiurl}/delete?id={id}',
                custom: '{apiurl}/{action}'
            },
            lwap : {
                index: '{apiurl}?act=_loadlist_&page={page}&pagesize={pagesize}',
                store: '{apiurl}?act=_create_',
                show: '{apiurl}?act=_show_&id={id}',
                edit: '{apiurl}?act=_loadedit_&id={id}',
                update: '{apiurl}?act=_modify_&id={id}',
                delete: '{apiurl}?act=_delete_&id={id}',
                opposite : '{apiurl}?act=_opposite_&id={id}&field={field}',
                custom: '{apiurl}?act={action}'
            }
        };

        function Api(config) {//api_url, url_style, url_params, ajax
            var that = this;
            var ajax = config.ajax || Ajax.make();
            this.config = function(){
                if (arguments.length) {
                    var arg0 = arguments[0];
                    if ( typeof(arg0) == 'string' ) {
                        return config[arg0];
                    } else {
                        config = arguments[0];
                    }
                } else {
                    return config;
                }
            },
            this.debug = function(){
                ajax.debug();
                return this;
            },
            this.buildUrl = function(action, params) {
                var replaces = angular.extend({}, params);
                replaces['apiurl'] = config.api_url;
                replaces['params'] = (function(){
                    var params = angular.extend({}, params || {}, config.url_params || {});
                    return $httpParamSerializer(params);
                })();
                var apiurl = url_styles[config.url_style][action];
                var link = apiurl.indexOf('?') > 0 ? '&' : '?';

                if (replaces['params']) apiurl += link + '{params}';
                for (var k in replaces) {
                    apiurl = apiurl.replace('{' + k + '}', replaces[k]);
                }
                return apiurl;
            },
            this.loading = function(is){
                ajax.loading(is);
                return this;
            },
            this.show = function(id, params){
                var url = this.buildUrl('show', {id:id});
                return ajax.get(url, params);
            },
            this.list = function(page, params, pagesize){
                var url = this.buildUrl('index', {page:page || 1, pagesize: pagesize ||''});
                return ajax.get(url, params);
            },
            this.edit = function(dat_id, params){
                var url = this.buildUrl('edit', {id:dat_id});
                return ajax.get(url, params);
            },
            this.create = function(data, params){
                var url = this.buildUrl('store');
                return ajax.post(url, data, params);
            },
            this.update = function(dat_id, data, params){
                var url = this.buildUrl('update', {id:dat_id});
                if ( config.url_style == 'restful' ) {
                    return ajax.put(url, data, params);
                } else {
                    return ajax.post(url, data, params);
                }
            },
            this.delete = function(dat_ids, params){
                if (angular.isArray(dat_ids)) dat_ids = dat_ids.join(',');
                var url = this.buildUrl('delete', {id:dat_ids});
                if ( config.url_style == 'restful' ) {
                    return ajax.delete(url, params);
                } else {
                    return ajax.post(url, params);
                }
            },
            this.opposite = function(dat_id, prop) {
                var url = this.buildUrl('opposite', {id:dat_id, prop:prop});
                return ajax.get(url);
            },
            this.get = function(action, params) {
                var url = this.buildUrl('custom', {action:action});
                return ajax.get(url, params);
            },
            this.post = function(action, data, params) {
                var url = this.buildUrl('custom', {action:action});
                return ajax.post(url, data, params);
            };
        }

        return {
            make : function(config){
                return new Api(config);
            }
        };
    }]);
;angular.module('Landers.angular')
    .provider('AngularModel', function() {
        var provider = this;

        this.$get = ['$templateRequest', 'List', 'Flat', 'AngularApi', 'Helpers', '$rootScope', function ($templateRequest, List, Flat, AngularApi, Helpers, $rootScope) {
            var is_api_result = function(rspn) {
                    if ( !angular.isObject(rspn)) return false;
                    return  'success' in rspn &&
                            'message' in rspn &&
                            'data' in rspn;
            };

            function Model(scope, config) { // key, name, api_url, url_style, url_params, [ajax, lister, vice]

                var that = this, watchers = [];

                //定义模型标识
                if (!config.key) throw ('未定义key字段');

                //将当前模型数据容器
                var modelkey = '$' + config.key;
                this.modelkey = modelkey;

                scope[modelkey] = {
                    '$name' : config.name,
                    '$list' : {
                        'data' : null,
                        'page' : null
                    },
                    '$create' : null,
                    '$detail' : null,
                    '$items' : {
                        selected:[],
                        selectedRows:[],
                    },
                    '$edit' : {},
                    '$form' : {},
                    '$update' : null,
                    '$modify' : null,
                    '$search' : null,
                    '$errors' : {
                        '$list' : null,
                        '$edit' : null,
                        '$form' : null,
                    },
                    '$runtime' : {},
                    '$event': {},
                    '$enums': {}
                };

                this.trigger = function(){
                    var fun, event, args = [];
                    for (var i=0; i<arguments.length; i++ ) {
                        if ( i== 0) {
                            event = arguments[i];
                        } else {
                            args.push(arguments[i]);
                        }
                    }
                    var fun = scope[modelkey].$event[event];

                    if ( fun ) {
                        fun.apply(scope[modelkey].$event, args)
                    }
                };

                this.getDataKey = function( key, subkey ) {
                    return modelkey + '.' + key + (subkey ? '.' + subkey : '');
                };

                this.extendData = function(key, extdata, subkey) {
                    var data = that.getData(key, subkey);
                    Flat.extend(data, extdata);
                    if (!scope.$$phase) scope.$apply();
                    return this;
                };

                this.setData = function(key, data, subkey) {
                    var datakey = modelkey + '.' + key;
                    Flat.set(scope, datakey, data, subkey);
                    if (!scope.$$phase) scope.$apply();
                    return this;
                };

                this.setDataToString = function(keys, subkey) {
                    if ( !angular.isArray(keys) ) keys = [keys];
                    keys.map(function(key){
                        var value = that.getData(key, subkey);
                        that.setData(key, value.toString(), subkey);
                    })
                };

                this.getData = function(key, subkey) {
                    var datakey = modelkey + '.' + key;
                    return Flat.get(scope, datakey, subkey);
                };

                this.watchers = [];
                this.watch = function(object, callback) {
                    if (angular.isString(object)) {
                        object = modelkey + '.' + object;
                    }
                    that.watchers.push(scope.$watch(object, callback));
                };
                this.destroyWatchers = function(){
                    for(var i=0; i<that.watchers.length; i++) {
                        that.watchers[i]();
                    }
                };

                this.clearErrors = function(key) {
                    that.setData('$errors', {}, key);
                };

                this.setErrors = function(key, data, message) {
                    for (var k in data) {
                        if (angular.isArray(data[k])) {
                            data[k] = data[k][0];
                        }
                    }
                    that.setData('$errors', data, key);

                    var isMsg;
                    if ( message === true || message === false) {
                        isMsg = message;
                        message = '提交的数据还存在不足！';
                    } else {
                        isMsg = true;
                    }

                    if (isMsg && message) Landers.response.msgbox({
                        success : false,
                        message : message
                    });

                    return message;
                };

                //定义钩子模块
                // 即将改名： hooks 改名为 hook
                this.hook = this.hooks = {
                    data : {
                        list:{
                            before:[],
                            after:[]
                        },
                        edit:{
                            onload:{
                                before:[],
                                after:[]
                            },
                            submit:{
                                before:[],
                                after:[]
                            }
                        },
                        close:[]
                    },
                    registe: function(key, fns) {
                        var _this = this;
                        if (!angular.isArray(fns)) fns = [fns];
                        angular.forEach(fns, function (fn){
                            if (angular.isFunction(fn)) {
                                Flat.push(_this.data, key, fn);
                            }
                        });
                    },
                    registeOnce: function(key, fn) {
                        if ( Flat.get(this.data, key).length ) return;
                        this.registe( key, fn);
                    },
                    run : function(key, params){
                        var _this = this;
                        var funs = Flat.get(_this.data, key);
                        angular.forEach(funs, function (fn){fn(params);});
                    }
                };

                //创建api与服务端通信对象
                config['api_url'] = config['api_url'] || ('/' + config.key);
                this.api = AngularApi.make(Landers.utils.json.slice(config, [
                    'api_url', 'url_style', 'url_params', 'ajax'
                ]));

                //定义列表操作对象
                // laravel输出分页时，数据位于 data字段中
                this.lister = config.lister || List.make(scope, modelkey + '.$list.data', null);

                //列表操作模块
                this.list = {
                    put:function(data) {
                        that.setData('$list', data);
                    },
                    data:function(data){
                        return that.lister.data(data);
                    },
                    clear:function(){
                        that.lister.clear();
                        that.listitem.selectAll(false);
                        that.setData('$list', {});
                        that.setData('$errors.$list', null);
                        return this;
                    },
                    doShow:function(ajax, opts){
                        opts = opts || {};
                        return ajax.success(function(rspn){
                            if (opts.handleResponse) {
                                opts.handleResponse(rspn);
                            }

                            if (is_api_result(rspn)) {
                                Landers.response.msgbox(rspn);
                                var data = rspn.data;

                                // data 部分是数组 (laravel不分页时)
                                if ( angular.isArray(data) ) {
                                    that.setData('$list', {
                                        data: rspn.data,
                                        page: null
                                    });
                                }

                                // lwap返回格式
                                if ( data.$list ) {
                                    data.$list.data = data.$list.data || [];
                                    data.$list.page = data.$list.page || null;
                                    that.setData('$list', data.$list);
                                }

                                // laravel分页返回格式
                                if ( data.data ) {
                                    that.setData('$list', {
                                        data: data.data,
                                        page: {
                                            current: data.current_page,
                                            last: data.last_page,
                                            size: data.per_page,
                                            total: data.total
                                        }
                                    });
                                }
                            } else {
                                if ( angular.isArray(rspn) ) {
                                    //RESTFUL 返回纯数据
                                    that.setData('$list.data', rspn);
                                }
                            }

                            that.hooks.run('list.after', rspn);
                            opts.onShow && opts.onShow(rspn);
                        }).error(function(rspn){
                            try {
                                that.setData('$errors.$list', rspn.message);
                                that.setData('$list', {data : [], page:{}});
                            } catch (e) {}
                        });
                    },
                    _params:{},
                    show:function(opts){
                        var _this = this;
                        opts = opts || {};
                        that.hooks.run('list.before');

                        var $search = that.getData('$search') || {};
                        for (var k in $search) {
                            if ( k.indexOf('$$$') === 0 ) delete $search.k;
                        }

                        angular.extend(_this._params, opts.params || {});
                        var params = angular.extend({}, _this._params, {
                            search:angular.toJson($search)
                        });
                        var doShow = function() {
                            var ajax = that.api.loading(opts.loading)
                                .list(opts.page, params, opts.pagesize || config.pagesize);
                            return _this.doShow(ajax, opts);
                        };

                        this.clear();
                        if (opts.callbackBefore) {
                            return opts.callbackBefore(doShow);
                        } else {
                            return doShow();
                        }
                    },

                    refresh:function(callback){
                        var opts = {
                            page: that.getData('$list.page.current') || 1,
                            params: {
                                search:angular.toJson(that.getData('$search'))
                            },
                            onShow: callback
                        };
                        this.show(opts);
                    },
                    ifRefresh : function(){
                        if (!that.lister.count()) this.refresh();
                    },
                    preAppend : function(data){
                        return that.lister.preAppend(data);
                    },
                    append : function(data) {
                        return that.lister.append(data);
                    }
                };

                //列表横操作模块
                this.item = this.listitem = {
                    showDeleteConfirm: function($event, item, item_name){
                        var _this = this;
                        Helpers.disable($event);
                        _this.active($event, true);

                        if (item) item.$busy = true;
                        var what_name = item_name ? ( config.name + '【' + item[item_name] + '】') : ('该' + config.name);
                        if (!confirm('确定要删除' + what_name + '吗？')) {
                            _this.active($event, false);
                            Helpers.enable($event);
                            if (item) item.$busy = false;
                            return false;
                        } else {
                            return true;
                        }
                    },
                    show:function(id, params){
                        return that.api.show(id, params)
                            .success(function(rspn){
                                that.setData('$detail', rspn.data);
                            })
                    },
                    data:function($event, key) {
                        return that.lister.item.data($event, key);
                    },
                    swap:function(item1, item2){
                        return that.api.get('swap-sorter/' + item1.id + '/' + item2.id)
                            .success(function(){
                                var index1 = that.lister.mapIndex(item1.id);
                                var index2 = that.lister.mapIndex(item2.id);
                                that.lister.item.swap(index1, index2);
                            })
                            .error(function(rspn){
                                Landers.response.msgbox(rspn);
                            });
                    },
                    moveUp:function(item1) {
                        var index1 = that.lister.mapIndex(item1.id), index2;
                        if (index1 === 0) {
                            return alert('当前项已经处于最前了');
                        } else {
                            index2 = index1 - 1;
                        }
                        var item2 = this.data(index2);
                        this.swap(item1, item2);
                    },
                    moveDown:function(item1){
                        var index1 = that.lister.mapIndex(item1.id), index2;
                        if (index1 == that.list.data().length-1) {
                            return alert('当前项已经处于最后了');
                        } else {
                            index2 = index1 + 1;
                        }
                        var item2 = this.data(index2);
                        this.swap(item1, item2);
                    },
                    count:function(){
                        var data = that.lister.data();
                        return data ? that.lister.data().length : -1;
                    },
                    update:function($event, dat, item){
                        if ( item ) {
                            angular.extend(item, dat);
                        } else {
                            that.lister.item.update($event, dat);
                        }
                    },
                    active:function($event, is_active){
                        return that.lister.item.active($event, is_active);
                    },
                    select:function($event, is_check){
                        return that.lister.item.select($event, is_check);
                    },
                    selectAll : function(bool){
                        var data = that.lister.data();
                        if ( !data ) return false;
                        data = bool ? data.map(function(item){return item.id || item.key;}) : [];
                        that.setData('$items', data, 'selected');
                    },
                    getSelectedId : function(alert_message){
                        if (alert_message === true) {
                            alert_message = '未选择目标数据！';
                        }
                        var ids = that.getData('$items', 'selected');
                        if ((!ids || !ids.length) && alert_message) {
                            alert(alert_message);
                            return null;
                        }
                        return ids;
                    },
                    remove:function(ids, lister) {
                        var _this = this;
                        if (!angular.isArray(ids)) {
                            ids = [ids];
                        }
                        var lister = lister || that.lister;
                        angular.forEach(ids, function(id){
                            var index = lister.mapIndex(id);
                            lister.item.remove(index);
                        });

                        var total = that.getData('$list.page.total');
                        if (total) {
                            that.setData('$list.page.total', total - ids.length);
                        }
                    },
                    deleteById:function(ids, lister){
                        var _this = this;
                        return that.api.delete(ids)
                            .success(function(rspn){
                                _this.remove(ids, lister);
                                that.list.ifRefresh();
                            });
                    },
                    // 被 dev_ssetting 重写 deleteItem 调用时，需要传入lister
                    delete:function(item, lister){
                        var _this = this;
                        return _this.deleteById(item.id, lister);
                    },
                    deleteSelected:function(callback){
                        var ids = this.getSelectedId(true);
                        if (!ids) return;
                        if ( !confirm('确定要删除选择的数据？')) return;
                        return this.deleteById(ids)
                            .success(function(rspn){
                                that.setData('$items', [], 'selected');
                                callback && callback(rspn);
                            });
                    }
                };

                this.addedit = {
                    doEdit: function(item, onLoad, params, hook){
                        var _this = this;
                        return that.api.edit(item.id, params || {})
                           .success(function(rspn){
                                var editData = (function(){
                                    if ( !rspn.data ) return rspn;
                                    if ( rspn.data.$edit ) return rspn.data.$edit;
                                    return rspn.data;
                                })();
                                if (editData) that.setData('$edit', editData);
                                onLoad && onLoad(rspn);
                                hook && hook(rspn);
                           });

                    },
                    doUpdate: function($event, item, onSubmit, hook){
                        var data = that.getData('$edit');
                        var _this = this;
                        return that.api.update(item.id, data)
                            .success(function(rspn){
                                var updated_data = null;

                                if ( is_api_result(rspn) ) {
                                    if ( rspn.data ) {
                                        updated_data = rspn.data.$modify || rspn.data.$update || rspn.data;
                                    }
                                } else {
                                    if ( angular.isObject(rspn) ) {
                                        updated_data = rspn;
                                    } else if (rspn === true) {
                                        updated_data = that.getData('$edit');
                                    }
                                }

                                if ( !updated_data ) {
                                    return that.list.refresh();
                                } else {
                                    that.listitem.update($event, updated_data, item);

                                    // 调用回调
                                    onSubmit && onSubmit(rspn);

                                    // 更新到模型缓存
                                    that.setData('$update', updated_data)

                                    // 调用钩子
                                    hook && hook(rspn);
                                }
                            });
                    },
                    doCreate: function(onSubmit, hook){
                        var data = that.getData('$edit');
                        var _this = this;
                        return that.api.create(data)
                            .success(function(rspn){
                                var created_data = null;

                                var page_info = that.getData('$list.page') || {};
                                if ( !('$total' in  page_info) ) {
                                    if ( is_api_result(rspn) ) {
                                        if ( rspn.data ) {
                                            created_data = rspn.data.$create || rspn.data;
                                        }
                                    } else {
                                        if ( angular.isObject(rspn) ) {
                                            created_data = rspn;
                                        } else if (rspn === true) {
                                            created_data = that.getData('$edit');
                                        }
                                    }
                                }

                                if ( !created_data ) {
                                    return that.list.refresh();
                                } else {
                                    that.list.preAppend(created_data);

                                    // 调用回调
                                    onSubmit && onSubmit(rspn);

                                    // 更新到模型缓存
                                    that.setData('$create', created_data)

                                    // 调用钩子
                                    hook && hook(rspn);
                                }
                            });
                    },
                    show: function($event, item, callback){
                        var action = item ?
                            {key : 'edit', text : '编辑', is_edit : true, datId: item.id, event:$event} :
                            {key : 'create', text : '添加', is_edit : false, datId:null, event:$event };

                        var _this = this;

                        var doLoad = function(onLoad, params){
                            that.setData('$edit', {});
                            that.setData('$errors.$edit', null);
                            that.hooks.run('edit.onload.before', {action:action});
                            that.setData('$runtime.is_edit', action.is_edit);
                            if (action.is_edit) {
                                return _this.doEdit(item, onLoad, params, function(rspn){
                                    that.hooks.run('edit.onload.after', {action:action, rspn:rspn});
                                });
                            } else {
                                onLoad && onLoad({});
                                that.hooks.run('edit.onload.after', {action:action});
                            }
                        };
                        var doSubmit = function(onSubmit){
                            that.hooks.run('edit.submit.before', {action:action});
                            return  action.is_edit ?
                                    _this.doUpdate($event, item, onSubmit, function(rspn){
                                        that.hooks.run('edit.submit.after', {action:action, rspn:rspn});
                                    }) :
                                    _this.doCreate( onSubmit, function(rspn){
                                        that.hooks.run('edit.submit.after', {action:action, rspn:rspn});
                                    });
                        };

                        callback(action, doLoad, doSubmit);
                    }
                };


                //新初始化$event, （注：必须不能用angular.extend来扩展，因为scope可能某子controller并继承了父controller）
                that.extendData('$event', {
                    selectAll : function($event) {
                        $event = angular.element($event.target);
                        var checked = $event.prop('checked');
                        that.listitem.selectAll(checked);
                    },
                    refreshList : function( callback ){
                        that.list.refresh( callback );
                    },
                    deleteItem : function($event, item, item_name) {
                        if ( !that.listitem.showDeleteConfirm($event, item, item_name) ) {
                            return {
                                success:function(){
                                    //donoting
                                    return this;
                                },
                                error:function(callback){
                                    callback();
                                    return this;
                                },
                                finally : function(callback) {
                                    callback();
                                    return this;
                                }
                            };
                        } else {
                            return that.listitem.delete(item)
                                .success(function(rspn){
                                    Landers.response.msgbox(rspn);
                                })
                                .error(function(rspn){
                                    Landers.response.msgbox(rspn);
                                    if (item) item.$busy = false;
                                    Helpers.enable($event);
                                })
                                .finally(function(){
                                    that.listitem.active($event, false);
                                });
                        }
                    },
                    deleteSelected : function() {
                        that.listitem.deleteSelected();
                    },
                    search : function(page){
                        var opts = {page : page};
                        var dat = that.getData('$search') || {};
                        if (dat._keyword_ || dat._keyword_by_) {
                            if (!dat._keyword_) {
                                return alert('未输入搜索关键词');
                            }
                            if (!dat._keyword_by_) {
                                return alert('未选择搜索关键词依据');
                            }
                        }
                        var ajax = that.list.show(opts);
                        if ( this.onSearch ) this.onSearch(ajax);
                    },
                    showPage : function(page){
                        var ajax = this.search(page);
                        if ( this.onShowPage ) this.onShowPage(ajax);
                    },
                    resetSearch : function(){
                        that.setData('$search', {});
                        scope.$emit('reset-search');
                        scope.$broadcast('reset-search');
                        that.list.show();
                    },
                    moveUp : function($event, item) {
                        that.listitem.moveUp(item);
                    },
                    moveDown : function($event, item) {
                        that.listitem.moveDown(item);
                    },
                    opposite : function($event, item, prop){
                        return that.api.opposite(item.id, prop)
                            .success(function(rspn){
                                console.log()
                                if ( angular.isObject(rspn.data) ) {
                                    item[prop] = rspn.data[prop];
                                }

                                if (
                                    rspn.data === true ||
                                    rspn.data === 1 ||
                                    rspn.data === false ||
                                    rspn.data === 0
                                ) {
                                    item[prop] = rspn.data;
                                }
                            });
                    }
                });

                that.extendData('$enums', $rootScope.$enums || $rootScope.Enums || {});

                scope.$on('$destroy', function(){
                    for (var i=0; i<watchers.length; i++) watches[i]();

                    Landers.response.hide();
                });
            }

            return {
                make:function(scope, config){
                    return new Model(scope, config);
                },
                isApiResult: is_api_result,
            };
        }];
    });
;angular.module('Landers.angular')
    .directive('crudDoItem', function(){
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                $element.addClass('doitem')
                    .children('a, button').not('.btn').addClass('btn ')
                    .each(function(){
                        if ($(this).attr('class').indexOf('btn-') < 0 ) {
                            $(this).addClass('btn-primary');
                        }
                    })
            }
        }
    })
    .provider('AngularApp', function () {
        var provider = this;

        this.cache = false;

        this.path = {
            module: null,
            component: null
        };

        this.extras = {};

        this.needCss = false;

        this.modulePath = function(module){
            return (provider.extras[module] || provider.path.module) + '/' + module;
        };

        provider.showDialogError = function(dialog, rspn) {
            if ( rspn.errors ) {
                errors = Object.values(rspn.errors);
                if ( rspn.message ) {
                    if (errors.length) rspn.message = '由于以下原因，导致' +  rspn.message + '：';
                    errors.unshift(rspn.message);
                }
                rspn.message = errors.join('\n');
            }
            dialog.done(rspn);
        };

        this.$get = ['$state', 'Ajax', 'Runtime', 'AngularModel', 'Dialog', '$templateRequest', 'Flat', '$timeout', 'InjectService', '$compile', 'Helpers', '$rootScope', function ($state, Ajax, Runtime, AngularModel, Dialog, $templateRequest, Flat, $timeout, InjectService, $compile, Helpers, $rootScope) {
            var defaults = {
                dialog : {
                    width : 800,
                    height : '100%',
                    scroll : true
                },
                partials: {

                }
            };

            function DynamicInjecte() {
                var that = this;
                function parse_path_info(path) {
                    var a = path.split('/');
                    if ( a.length == 1) {
                        return {dir: path, file: ''} ;
                    } else {
                        var file = a[a.length-1];
                        a.length--;
                        return {
                            dir: a.join('/'),
                            file: file
                        };
                    }
                }

                this.getAppResourcesUrl = function(module){
                    var base_path = provider.modulePath(module);
                    return [
                        base_path + '/style.css',
                        base_path + '/client.js'
                    ];
                };
                this.injectedModules = {};
                this.injectModule = function(module, injects){
                    var modules = that.injectedModules[module];
                    if (!modules) {
                        var urls = that.getAppResourcesUrl(module);
                        InjectService.module(urls, injects);
                    } else {
                        callback.apply(this, modules);
                    }
                };
                this.injectedApps = {};
                this.bootApp = function(scope, path, callback_controller) {
                    var path_info = parse_path_info(path);
                    var urls = that.getAppResourcesUrl(path_info.dir);
                    if (!that.injectedApps[path]) {
                        InjectService.urls(urls, function(){
                            if (angular.isString(callback_controller)) {
                                that.bootController(scope, callback_controller);
                            }
                            if (angular.isFunction(callback_controller)){
                                var mod_path = provider.modulePath(path_info.dir); // provider.path.module + '/' + path_info.dir;
                                var main_url = mod_path + '/' + (path_info.file || 'layout.html');
                                that.bootController(scope, main_url);
                                $timeout(callback_controller, 200);
                            }
                            that.injectedApps[path] = true;
                        });
                    } else {
                        if (angular.isFunction(callback_controller)){
                            callback_controller && callback_controller();
                        }
                    }
                };
                this.injectedControllers = {};
                this.bootController = function (scope, controller_url, reload){
                    if (!that.injectedControllers[controller_url] || reload) {
                        var html = controller_url.indexOf('/') >= 0 ?
                                   '<div ng-include="\'' + controller_url + '\'"></div>' :
                                   '<div ng-controller="' + controller_url + '"></div>';
                        var el = $compile(html)(scope);
                        angular.element('#base-body, .base-body').append(el);
                        if (!scope.$$phase) scope.$apply();
                        that.injectedControllers[controller_url] = true;
                    };
                };
                this.resetInjectCache = function( key ) {
                    if ( key ) {
                        that[key] = {};
                    } else {
                        that.injectedControllers = {};
                        that.injectedApps = {};
                        that.injectedModules = {};
                    }
                };
            }


            function AngularApp(scope, config) {
                config = $.extend(true, {}, defaults, config);

                //初始化全局变量
                var that = this,
                    doms = [];

                this.scope = scope;
                scope.$APPS = scope.$APPS || {};
                scope.$APPS[config.key] = this;

                //初始化 key, name
                this.key = config.key;
                this.name = config.name;

                //初始化path
                this.path = provider.modulePath(config.path || that.key);

                if ( !scope.hasOwnProperty('$partial') ) {
                    scope.$partial = function(partial, path){
                        if (path === undefined && config.partials) {
                            path = config.partials[partial];
                            if ( path ) return path;
                        }

                        if ( !path ) {
                            path = that.path;
                        } else if ( path === true ) {
                            path = provider.path.component;
                        } else {
                            path = that.path + '/../' + path;
                        }

                        var html_url = path + '/partials/' +  partial + '.html';
                        // if ( !provider.cache ) html_url += '?_=' + Math.random();
                        return html_url;
                    };
                }

                //加载css
                if (provider.needCss) {
                    var css_url = that.path + '/style.css';
                    if ( !provider.cache ) css_url += '?_=' + Math.random();
                    doms.push(Landers.loader.css(css_url));
                }

                //初始化ajax
                this.ajax = Ajax.make();

                //初始化runtime (挂载$runtime至scope)
                this.runtime = Runtime.make(scope);
                this.runtime.set('referer', document.referrer);
                this.runtime.set('$app', this);

                this.$ = {
                    _datkey : function(objectkey, subkey){
                        var datkey = ['$' + objectkey];
                        if (subkey) datkey.push(subkey);
                        return datkey.join('.');
                    },
                    get : function(objectkey, subkey) {
                        var datkey = this._datkey(objectkey, subkey);
                        return Flat.get(scope, datkey);
                    },
                    set : function(objectkey, data, subkey) {
                        var datkey = this._datkey(objectkey);
                        Flat.set(scope, datkey, data, subkey);
                        if (!scope.$$phase) scope.$apply();
                    },
                    extend : function(objectkey, data) {
                        var datkey = this._datkey(objectkey);
                        Flat.extend(scope, data, datkey);
                        if (!scope.$$phase) scope.$apply();
                    }
                };

                //对话框
                this.dialog = {
                    dialogs : [],
                    _attachConfig : function(_dialog_config){
                        var dialog_config = angular.extend({}, _dialog_config);
                        if (_dialog_config.event) {
                            if (that.model) {
                                that.model.listitem.active(_dialog_config.event, true);
                            }
                            dialog_config.onclose = function(){
                                if (that.model) {
                                    that.model.listitem.active(_dialog_config.event, false);
                                }
                                _dialog_config.onclose && _dialog_config.onclose.call(this);
                            };
                            delete dialog_config.event;
                        }
                        if ( _dialog_config.bottombarPartial ) {
                            var bottombar_url = scope.$partial( _dialog_config.bottombarPartial, _dialog_config.partial_path );
                            dialog_config.bottombar = '<div ng-include src="\'' + bottombar_url + '\'"></div>';
                        }

                        if ( _dialog_config.statusbarPartial ) {
                            var bottombar_url = scope.$partial( _dialog_config.statusbarPartial, _dialog_config.partial_path );
                            dialog_config.statusbar = '<div ng-include src="\'' + bottombar_url + '\'"></div>';
                        }
                        // dialog_config.blur = false;
                        return dialog_config;
                    },
                    _loadPartial : function(dialog_config, callback){
                        var partial_url;
                        if ( dialog_config.partial ) {
                            if ( dialog_config.partial.indexOf('/') >= 0) {
                                partial_url = dialog_config.partial;
                            } else {
                                partial_url = scope.$partial( dialog_config.partial, dialog_config.partial_path );
                            }
                        } else {
                            throw ('参数错误');
                        }
                        $templateRequest(partial_url).then(function(html){
                            callback(html);
                        });
                    },

                    show : function(_dialog_config){
                        var dialog_config = this._attachConfig(_dialog_config);
                        var _this = this;
                        var _show = function(){
                            var dialog = Dialog.show(scope, dialog_config);
                            _this.dialogs.push(dialog);
                        };
                        if (dialog_config.partial) {
                            _this._loadPartial(dialog_config, function(html){
                                dialog_config.html = html;
                                _show();
                            });
                        } else {
                            _show();
                        }
                    },

                    // show : function(_dialog_config){
                    //     dialog_config = this._attachConfig(_dialog_config);
                    //     var _this = this;
                    //     _this._loadPartial(dialog_config, function(html){
                    //         dialog_config.html = html;
                    //         var dialog = Dialog.show(scope, dialog_config);
                    //         _this.dialogs.push(dialog);
                    //     });
                    // },
                    confirmWithPartial : function(dialog_config, callbacks){
                        dialog_config = this._attachConfig(dialog_config);
                        var _this = this;
                        _this._loadPartial(dialog_config, function(html){
                            dialog_config.html = html;
                            var dialog = Dialog.confirm(scope, dialog_config, callbacks);
                            _this.dialogs.push(dialog);
                        });
                    },
                    // 传入要显示的内容和按钮的回调
                    confirm : function(content, callbacks, $event){
                        callbacks.yesFn = callbacks.yesFn || function () {};
                        callbacks.noFn = callbacks.noFn || function () {};

                        // 处理content内容
                        content = content.replace(/&/g, "&amp;")
                            .replace(/</g, "&lt;")
                            .replace(/>/g, "&gt;");

                        dialog_config = this._attachConfig({
                            content: '<div class=\"confirm\">' + content + '</div>',
                            title: '来自'+window.location.host+'的消息',
                            width: 300,
                            event: $event
                        });

                        var dialog = Dialog.confirm(scope, dialog_config, callbacks);
                        this.dialogs.push(dialog);
                    }
                };

                //初始化model
                this.appkey = '$' + config.key;

                if (config.model !== false) {
                    this.model = AngularModel.make(scope, {
                        key : that.key,
                        name : that.name,
                        path: {

                        },
                        api_url: (function(){
                            if ( config.api_url ) {
                                return config.api_url;
                            }
                            if ( config.url_style == 'lwap') {
                                return that.path + '/server.php';
                            }
                            return '/' + config.key;
                        })(),
                        url_style : config.url_style,
                        url_params : (function(){
                            var parent_source = config.parent_source;
                            var ret = config.url_params || {};
                            //新参数parent_source
                            if (parent_source && parent_source.app) {
                                ret.related_key = parent_source.app.key;
                                if ( parent_source.listitem ) {
                                    ret.related_id = parent_source.listitem.id
                                }
                            };
                            //兼容老参数parentApp
                            if (config.parentApp && config.parentApp.prop) {
                                ret.appid = config.parentApp.prop.appid;
                                if ( config.parentEvent ) {
                                    ret.datid = config.parentApp.model.listitem.data(config.parentEvent, 'id');
                                }
                            };
                            return ret;
                        })(),
                        ajax: that.ajax,
                        vice: config.vice,
                        pagesize: config.pagesize,
                        template_urls: config.template_urls
                    });

                    //model.list.popup
                    this.model.list.popup = function(_dialog_config, url_params, callback){
                        var _this = this; url_params = url_params || {};
                        var dialog_config = that.dialog._attachConfig(_dialog_config);
                        dialog_config.onload = function(){
                            var dialog = this.done();
                            var ajax = _this.show({params: url_params});
                            callback && callback(ajax);
                            _dialog_config.onload && _dialog_config.onload.call(dialog);
                            setTimeout(function(){dialog.position();}, 300);
                        };

                        dialog_config = angular.extend({}, {
                            partial : dialog_config.partial || 'lister',
                            scroll : true,
                            height : '100%',
                            no : true
                        }, dialog_config);
                        that.dialog.show(dialog_config);
                    };

                    this.model.detail = {
                        show: function(item, params) {
                            return that.model.listitem.show(item.id, params);
                        },
                        popup: function(item, _dialog_config, params) {
                            var _this = this;
                            var dialog_config = that.dialog._attachConfig(_dialog_config);
                            dialog_config.onload = function() {
                                var dialog = this.done();
                                _this.show(item, params)
                                    .error(function(rspn) {
                                        dialog.done(rspn);
                                    })
                                    .finally(function(){
                                        _dialog_config.onload && _dialog_config.onload.call(this);
                                        setTimeout(function(){dialog.position();}, 300);
                                    });
                            };

                            dialog_config = angular.extend({}, {
                                partial: dialog_config.partial || 'detail',
                                scroll: true,
                                loading: {size:'small'},
                                height: '100%',
                                no: true
                            }, dialog_config);
                            that.dialog.show(dialog_config);
                        }
                    }

                    this.model.addedit.popup = function($event, item, _dialog_config) {
                        var dialog_config = that.dialog._attachConfig(_dialog_config);
                        dialog_config.partial = dialog_config.partial || dialog_config.tplkey || 'form';

                        var _this = this, globalDialog;
                        that.dialog._loadPartial(dialog_config, function(dialog_html){
                            _this.show($event, item, function (action, doLoad, doSubmit){
                                if (action.is_edit && dialog_config.loading === undefined) {
                                    dialog_config.loading = {size:'small'};
                                }
                                dialog_config = angular.extend({}, dialog_config, {
                                    event : $event,
                                    title : action.text + (dialog_config.name || that.name),
                                    html: dialog_html,
                                    onload : function(){
                                        globalDialog = this.done();
                                        var onBeforeLoad = dialog_config.onBeforeLoad;
                                        var _onAfterLoad = function(rspn){
                                            var onAfterLoad = dialog_config.onAfterLoad;
                                            onAfterLoad && onAfterLoad.call(that, action, globalDialog, rspn);

                                            if ( AngularModel.isApiResult(rspn) ) globalDialog.done(rspn); else globalDialog.done();
                                        };
                                        var _doLoad = function(){
                                            doLoad(_onAfterLoad);
                                        };
                                        $timeout(function() {
                                            if ( onBeforeLoad ) {
                                                onBeforeLoad(action, globalDialog, _doLoad);
                                            } else {
                                                _doLoad();
                                            }
                                        }, 100);
                                    },
                                    yes : {
                                        text:'保存', fn:function(window, button){
                                            Helpers.disable($(button));
                                            var onBeforeSubmit = dialog_config.onBeforeSubmit;
                                            var onAfterSubmit = dialog_config.onAfterSubmit;
                                            var _doSubmit = function(){
                                                doSubmit()
                                                    .success(function(rspn){
                                                        Helpers.enable($(button));
                                                        onAfterSubmit && onAfterSubmit(action, globalDialog, rspn, item);
                                                        if (!rspn.message) {
                                                            globalDialog.done().close();
                                                        } else {
                                                            if ( action.is_edit ) {
                                                                globalDialog.done(rspn).btn().get('取消').text('关闭');
                                                            } else {
                                                                globalDialog.done().close();
                                                                Landers.response.msgbox(rspn);
                                                            }
                                                        }
                                                    })
                                                    .error(function(rspn){
                                                        if ( angular.isObject(rspn.errors) ) {
                                                            var message = that.model.setErrors('$edit', rspn.errors, false);
                                                            rspn.message = rspn.message || message;
                                                        }
                                                        provider.showDialogError(globalDialog, rspn);
                                                        Helpers.enable($(button));
                                                    });
                                            };

                                            globalDialog.loading({
                                                text : '正在提交数据...',
                                                size : 'long'
                                            }, function(callback_result){
                                                $timeout(function() {
                                                    if ( onBeforeSubmit ) {
                                                        onBeforeSubmit(action, globalDialog, _doSubmit);
                                                    } else {
                                                        _doSubmit();
                                                    }
                                                }, 100);
                                            });
                                            return false;
                                        }
                                    },
                                    no : '取消'
                                });
                                dialog_config.onclose = dialog_config.onclose || function(){
                                    scope.$broadcast('destroy_ueditor');
                                    that.model.setData('$edit', {});
                                };
                                that.dialog.show(dialog_config);
                            });
                        });
                    };

                    this.action = {
                        loading:function(){
                            if (that.ajax) that.ajax.loading();
                            return this;
                        },
                        post : function(action, data, params) {
                            var apiurl = that.model.api.buildUrl('custom', {action:action});
                            if (!data && that.model) data = that.model.getData('$edit');
                            if (that.ajax) return that.ajax.post(apiurl, data, params);
                        },
                        get : function(action, params) {
                            var apiurl = that.model.api.buildUrl('custom', {action:action});
                            if (that.ajax) return that.ajax.get(apiurl, params);
                        }
                    };

                    this.appkey = this.model.modelkey;
                }

                this.injectClient = function(name, injects){
                    var url = that.path + '/' + 'client-' + name + '.js';
                    InjectService.module([url], injects);
                };

                this.service = {
                    tagsInput : function(fields){
                        if (!angular.isArray(fields)) fields = [fields];
                        angular.forEach(fields, function(item){
                            var value = that.model.getData('$edit', item);
                            that.runtime.set(item, {
                                data : value ? value.toString().split(',') : [],
                                onChange : function(){
                                    value = this.data.map(function(item){
                                        return item.text;
                                    }).join(',');
                                    that.model.setData('$edit', value, item);
                                }
                            });
                        });
                    }
                };

                //扩展或覆盖$event
                if ( that.model ) {
                    that.model.extendData('$event', {
                        showEdit:function($event, item){
                            $timeout(function() {
                                config.dialog.name = config.name;
                                config.dialog.partial = config.dialog.partial || 'form';
                                that.model.addedit.popup($event, item, config.dialog);
                            }, 100);
                        },
                        showCreate:function($event){
                            this.showEdit($event);
                        }
                    });
                    that.model.extendData('$event', config.events || {});

                } else {
                    Flat.set(scope, that.appkey, config.events, '$event');
                    if (!scope.$$phase) scope.$apply();
                }

                //初始化
                // scope.$errors = {};

                //scope销毁时事件
                scope.$on('$destroy', function(){
                    //todo: 要调用下面 return对象中的reset
                    that.resetInjectCache();

                    //断开所有连接
                    that.ajax.cancelAll();

                    //清除doms
                    angular.forEach(doms, function(dom){
                        dom.remove();
                    });

                    // Landers.dialog.clear && Landers.dialog.clear();
                    angular.forEach(that.dialog.dialogs, function(dialog){
                        if (dialog && dialog.close) {
                            dialog.close();
                        }
                    });

                    Landers.response.hide();

                    delete that.ajax;
                    delete that.model;
                    delete that.runtime;
                    delete that.$;
                    delete that.scope;
                });

                this.__proto__ = new DynamicInjecte();
            }

            return {
                make : function(scope, config){
                    return new AngularApp(scope, config);
                },
                graft: function( scope, mod_name ){
                    return Flat.get(scope, ['$APPS', mod_name].join('.'));
                },
                partial: function(path, partial) {
                    return provider.modulePath(path) + '/partials/' +  partial + '.html';
                },
                provider: provider,
                launch:function(key) {
                    $state.go('base.' + key);
                },
                __proto__: new DynamicInjecte
            };
        }];
    });
;angular.module('Landers.angular')
    .factory('EchartsService', function(){
        var planePath = 'path://M1705.06,1318.313v-89.254l-319.9-221.799l0.073-208.063c0.521-84.662-26.629-121.796-63.961-121.491c-37.332-0.305-64.482,36.829-63.961,121.491l0.073,208.063l-319.9,221.799v89.254l330.343-157.288l12.238,241.308l-134.449,92.931l0.531,42.034l175.125-42.917l175.125,42.917l0.531-42.034l-134.449-92.931l12.238-241.308L1705.06,1318.313z';
        // var color = ['#a6c84c', '#ffa022', '#46bee9'];
        var curveness = 0.2;

        var that;

        return {
            init : function(id){
                that = that || this;

                if (!window.echarts) throw '未加载echarts库';
                var dom = document.getElementById(id);
                if (!dom) throw '未找到dom对象：' + id;

                var chart = echarts.init(dom);
                $(window).on('resize', chart.resize);

                return chart;
            },

            destroy : function(chart) {
                $(window).off('resize', chart.size);
                chart.dispose();
            },
            map : {
                getPosByGeo : function(chartInstance, point, serie_index) {
                    var seriesModel = chartInstance.getModel();
                    if (seriesModel) {
                        var series = seriesModel.getSeriesByIndex(serie_index);
                        var coordSys = series.coordinateSystem;
                        var coord = coordSys.dataToPoint([point.lng, point.lat]);
                        return {left : coord[0], top : coord[1]};
                    } else {
                        console.log('seriesModel 为空！');
                        return {left : 0, top : 0};
                    }
                },
                getGeoByPos : function(chartInstance, coord, serie_index) {
                    var seriesModel = chartInstance.getModel();
                    if ( seriesModel ) {
                        var series = seriesModel.getSeriesByIndex(serie_index);
                        var coordSys = series.coordinateSystem;
                        var point = coordSys.dataToPoint([coord.x, coord.y]);
                        return {lng : point[0], lat : point[1]};
                    } else {
                        console.log('seriesModel 为空！');
                        return {lng : 0, lat : 0};
                    }
                },
                buildPath: function(from, tos) {
                    var ret = [];
                    angular.forEach(tos , function(to){
                        ret.push([{
                            coord: [to.lng, to.lat]
                        }, {
                            coord: [from.lng, from.lat]
                        }]);
                    });
                    return ret;
                },

                //轨迹
                track : function(name, dest, srcs) {
                    return {
                        name: name,
                        type: 'lines',
                        zlevel: 300,
                        effect: {
                            show: true,
                            period: 6,
                            trailLength: 0.1,
                            color: '#fff',
                            symbolSize: 3,
                        },
                        lineStyle: {
                            normal: {
                                // color: '#xxxxxx',
                                width: 0,
                                trailLength: 0.1,
                                curveness: curveness
                            }
                        },
                        data: that.map.buildPath(dest, srcs)
                    };
                },

                //线条
                line : function(dest, srcs, color) {
                    return {
                        name: dest.ip,
                        type: 'lines',
                        zlevel: 100,
                        effect: {
                            show: true,
                            period: 6,
                            trailLength: 0,
                            symbol: 'none',
                            symbolSize: 0
                        },
                        lineStyle: {
                            normal: {
                                color: color, //that.colors.src[type].line,
                                width: 1,
                                opacity: 0.1,
                                curveness: curveness
                            }
                        },
                        data: that.map.buildPath(dest, srcs)
                    };
                },

                //点
                dot : function(name, dots, color, zlevel) {
                    return {
                        name: name,
                        type: 'effectScatter',
                        coordinateSystem: 'geo',
                        legendHoverLink : true,
                        zlevel: zlevel,
                        rippleEffect: {
                            brushType: 'stroke'
                        },
                        label: {
                            normal: {
                                show: true,
                                position: 'right',
                                formatter: '{b}'
                            }
                        },
                        symbolSize: function (val) {
                            return val[2];
                        },
                        itemStyle: {
                            normal: {
                                color: color
                            }
                        },
                        data: dots.map(function (dot) {
                            return angular.extend({}, {
                                name: '',
                                // symbol : 'arrow',
                                value : [dot.lng, dot.lat, dot.level]
                            }, dot);
                        })
                    };
                },

                option : function(legends, series, opts){
                    opts = opts || {};
                    opts.legend = opts.legend || {};
                    return {
                        // backgroundColor: '#404a59',
                        title : {
                            text: '',
                            subtext: '',
                            left: 'center',
                            textStyle : {
                                color: '#fff'
                            }
                        },
                        tooltip : {
                            show : false,
                            trigger: 'item'
                            // formatter : function(item){
                            //     var data = item.data;
                            //     //只显示攻击目标的信息
                            //     if (data.kind == 'dest') {
                            //         var content = [];
                            //         content.push( '攻击流量：' + data.bps + 'Gbps');
                            //         content.push( '攻击报文：' + data.pps + 'pps');
                            //         return content.join('<br/>');
                            //     } else {
                            //         return null;
                            //     }
                            // }
                        },
                        legend: {
                            orient: 'vertical',
                            top: opts.legend.top,
                            bottom:opts.legend.bottom,
                            left: opts.legend.left,
                            right: opts.legend.right,
                            align: opts.legend.align,
                            // data:['北京 Top10', '上海 Top10', '广州 Top10'],
                            data: legends,
                            textStyle: {
                                color: '#fff'
                            },
                            selectedMode: 'single'
                        },
                        geo: {
                            map: 'world',
                            label: {
                                emphasis: {
                                    show: false
                                }
                            },
                            roam: true,
                            itemStyle: {
                                normal: {
                                    areaColor: '#323c48',
                                    borderColor: '#404a59'
                                },
                                emphasis: {
                                    areaColor: '#2a333d'
                                }
                            }
                        },
                        series: series
                    };
                }
            },

            // line : {
            //     option : function(categories, datas){
            //         return  {
            //             title: {
            //                 text: ''
            //             },
            //             tooltip : {
            //                 trigger: 'axis',
            //                 axisPointer : {            // 坐标轴指示器，坐标轴触发有效
            //                     type : 'shadow',        // 默认为直线，可选为：'line' | 'shadow'
            //                     animation: false
            //                 }
            //             },
            //             toolbox: {
            //                 feature: {
            //                     saveAsImage: {}
            //                 }
            //             },
            //             grid: {
            //                 left: '3%',
            //                 right: '4%',
            //                 bottom: '3%',
            //                 containLabel: true
            //             },
            //             xAxis : [
            //                 {
            //                     type : 'category',
            //                     boundaryGap : false,
            //                     data : categories
            //                 }
            //             ],
            //             yAxis : [
            //                 {
            //                     type : 'value'
            //                 }
            //             ],
            //             series :[
            //                 {
            //                     name:'',
            //                     type:'line',
            //                     // stack: '总量',
            //                     areaStyle: {normal: {}},
            //                     data:datas
            //                 }
            //             ]
            //         }
            //     }
            // },

            // bar : {
            //     option : function(categories, datas){
            //         return {
            //             color: ['#3398DB'],
            //             tooltip : {
            //                 trigger: 'axis',
            //                 axisPointer : {            // 坐标轴指示器，坐标轴触发有效
            //                     type : 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
            //                 }
            //             },
            //             toolbox: {
            //                 feature: {
            //                     saveAsImage: {}
            //                 }
            //             },
            //             grid: {
            //                 left: '3%',
            //                 right: '4%',
            //                 bottom: '3%',
            //                 containLabel: true
            //             },
            //             xAxis : [
            //                 {
            //                     type : 'category',
            //                     data : categories,
            //                     axisTick: {
            //                         alignWithLabel: true
            //                     }
            //                 }
            //             ],
            //             yAxis : [
            //                 {
            //                     type : 'value'
            //                 }
            //             ],
            //             series : [
            //                 {
            //                     name:'',
            //                     type:'bar',
            //                     barWidth: '60%',
            //                     data:datas
            //                 }
            //             ]
            //         };
            //     }
            // }
        };
    });
;angular.module('Landers.angular')
    .directive('landersAttachment', ['$compile', 'Flat', 'Dialog', 'List', function($compile, Flat, Dialog, List) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                var model_key = $attrs['attachModel'];
                var view_key = $attrs['attachView'];

                var html = '';
                html += '<div class="relative">';
                html += '   <a ng-click="landersAttachmentAdd($event)" class="btn btn-sm btn-primary absolute right-top"><i class="glyphicon glyphicon-plus"></i></a>';
                html += '</div>';
                html += '<input ng-model="' + model_key + '" type="hidden"/>';
                html += '<ul class="hlist list">';
                html += '    <li ng-repeat="item in ' + view_key + '" class="mr20 list-item">';
                html += '        <a href="{{item.url}}" target="_blank">{{item.title}}</a>';
                html += '        <a ng-click="landersAttachmentRemove($event)" class="ml5 btn btn-warning btn-xs"><i class="glyphicon glyphicon-minus"></i></a>';
                html += '    </li>';
                html += '</ul>';
                console.log(html);
                var el = $compile(html)($scope);
                $element.css({height:'100%'}).append(el);
                if (!$scope.$$phase) $scope.$apply();
                $element.find('.list').css({'margin-right':$element.find('.btn').width() + 20 })

                var lister = List.make($scope, view_key).data([]);
                $scope.$watch(model_key, function(model){
                    if (model) lister.data(model);
                });
                var html = '';
                html += '<form class="form-horizontal">';
                html += '<input type="hidden" id="url" ng-model="$runtime.attachment.url"/>';
                html += '<table cellpadding="0" cellspacing="0" border="0" class="stereo form-table" style="width:520px;">';
                html += '    <tr>';
                html += '       <td><label class="control-label">标题</label></td>';
                html += '       <td><div class="control-input"><input type="text" class="form-control" ng-model="$runtime.attachment.title"/></div></td>';
                html += '    </tr>';
                html += '    <tr height="192">';
                html += '       <td><label class="control-label">上传</label></td>';
                html += '       <td><div class="control-input">';
                html += '            <div landers-upload class="upload text-center fl" rel="url" uploadid="7b2aa8e6ba1d06fae48d72ae28dc7469" tipid="upload_attachment_tip" pvw="180" pvh="180"></div>';
                html += '            <ul id="upload_attachment_tip" class="fl lh22"></ul>';
                html += '        </div></td>';
                html += '    </tr>';
                html += '</table>';
                html += '</form>';
                angular.extend($scope, {
                    landersAttachmentAdd : function(){
                        Flat.set($scope, '$runtime.attachment', {});
                        setTimeout(function(){
                            Dialog.show($scope, {
                                title   : '新增附件',
                                content : html,
                                top : '30%',
                                width   : 350,
                                lock    : true,
                                fixed   : true,
                                effect  : 'vmove2',
                                onload  : function(){
                                },
                                yes     : function(){
                                    var attach = Flat.get($scope, '$runtime.attachment');
                                    lister.append(angular.extend({}, attach));
                                    Flat.set($scope, model_key, angular.toJson(lister.data()));
                                },
                                no      : true
                            });
                        }, 200);
                    },
                    landersAttachmentRemove : function($event){
                        if (!confirm('确定要删除此附件？')) return;
                        lister.item.remove($event);
                        Flat.set($scope, model_key, angular.toJson(lister.data()));
                    }
                })
            }
        }
    }]);
;angular.module('Landers.angular')
    .directive('landersTab', ['Flat', function(Flat) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                Landers.loader.jsm(['landers.tab,true'], function(){
                    $element.itab();
                });
            }
        };
    }]);
;angular.module('Landers.angular')
    .directive('landersUpload', function($rootScope, Flat) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs) {
                var upload_host_url = $attrs['uploadHostUrl'];
                var upload_api_url = $attrs['uploadApiUrl'];
                Landers.loader.jsm(['landers.iframe', 'landers.upload,true'], function(){
                    var $form = $element.closest('form');
                    var rel = $element.attr('rel');
                    var $rel = $form.find('#' + rel);
                    var relModel = $rel.attr('ng-model');
                    $rel.val(Flat.get($scope, relModel) || '');

                    var relsmall = $element.attr('rel_small');
                    if (relsmall) {
                        var $relsmall = $form.find('#' + relsmall);
                        var relsmallModel = $relsmall.attr('ng-model');
                        $relsmall.val(Flat.get($scope, relsmallModel) || '');
                    }
                    var tipid = $element.attr('tipid');
                    var $tip = $form.find('#' + tipid);
                    var params = $element.attr('params');
                    if (params) params = angular.fromJson(params); else params = {};
                    $scope.$watch(
                        function(){return $rel.val()},
                        function(newValue){
                            Flat.set($scope, relModel, newValue);
                        }
                    );
                    if (relsmall && $relsmall.length && relsmallModel) {
                        $scope.$watch(
                            function(){return $relsmall.val()},
                            function(newValue){
                                Flat.set($scope, relsmallModel, newValue);
                            }
                        );
                    };
                    var opts = {scope:$scope};
                    if (relsmall && $relsmall.length) opts.$small = $relsmall;
                    if ($tip.length)  opts.$tip = $tip;
                    opts.faces = $element.attr('faces') || 0;

                    var pvw = $element.attr('pvw'), pvh = $element.attr('pvh');
                    if (pvw || pvh) {
                        opts.pvsize = {};
                        if (pvw) opts.pvsize.width = pvw;
                        if (pvh) opts.pvsize.height = pvh;
                    };
                    opts.onload = function(){
                        var upload = this;
                        if (params.init_logo) {
                            var $faces = upload.getfaces();
                            $faces.each(function(){
                                Upload.plug.attach_setlogo($(this), params.init_logo, 'val_small');
                            });
                        };
                    };
                    opts.onchange = function(){
                        if (!$scope.$$phase) $scope.$apply();
                    };
                    opts = $.extend({}, opts, params);
                    opts.hosturl = upload_host_url || $rootScope.$settings.env.upload_host_url;
                    opts.debug = !!params.debug;
                    Landers.upload.create(
                        $element.attr('uploadid'),
                        upload_api_url || params.apiurl || 'upload.php',
                        $element, $rel, opts
                    );
                });
            }
        };
    });
;angular.module('Landers.angular')
    .directive('landersTreeSelect', ['$timeout', function($timeout) {
        return {
            restrict : 'A',
            require: 'ngModel',
            link : function($scope, $element, $attrs, ngModel){
                Landers.loader.jsm(['landers.treeselect'], function(){
                    var source = $attrs.source;
                    $scope.$watch(source, function(newValue){
                        $element.children().remove();
                        Landers.treeselect.select({
                            contain: $element, data:newValue, root:['', '选择分类']
                        });
                        var precache = $element.data('precache');
                        $element.val(precache);
                    });
                    if (!$scope.$$phase) $scope.$apply();

                    $scope.$watch($attrs['ngModel'], function(newValue){
                        $element.data('precache', newValue);
                        $element.val(newValue);
                    });
                });
            }
        };
    }]);

// /**
// Created by Dio on 17-9.
// http://inhu.net
//  */

(function() {
    "use strict";
    (function() {
        var NGUeditor, Editors = {};
        NGUeditor = angular.module("ng.ueditor", []);
        NGUeditor.directive("ueditor", function($timeout) {
                return {
                    restrict: "C",
                    require: "ngModel",
                    scope: {
                        config: "=",
                        ready: "="
                    },
                    link: function($S, element, attr, ctrl) {
                        var _NGUeditor, _updateByRender;
                        _updateByRender = false;
                        _NGUeditor = (function() {
                            function _NGUeditor() {
                                this.bindRender();
                                this.initEditor();
                                return;
                            }

                            /**
                             * 初始化编辑器
                             * @return {[type]} [description]
                             */
                            _NGUeditor.prototype.delEditor = function(_editorId) {
                                if (UE.delEditor && Editors[_editorId]) {
                                    Editors[_editorId].removeListener("contentChange");
                                    UE.delEditor(_editorId);
                                    Editors[_editorId] = null;
                                    delete Editors[_editorId];
                                    this.editor = null;
                                }
                            };

                            _NGUeditor.prototype.initEditor = function() {
                                var _UEConfig, _editorId, _self;
                                _self = this;
                                if (typeof UE === 'undefined') {
                                    console.error("Please import the local resources of ueditor!");
                                    return;
                                }
                                _UEConfig = $S.config ? $S.config : {};
                                _editorId = attr.id ? attr.id : "_editor" + (Date.now());
                                element[0].id = _editorId;
                                if (Editors[_editorId]) {
                                    _self.delEditor(_editorId);
                                };
                                $timeout(function(){
                                    _self.editor = new UE.ui.Editor(_UEConfig);
                                    Editors[_editorId] = _self.editor;
                                    _self.editor.render(_editorId);
                                    _self.editor.ready(function() {
                                        _self.editorReady = true;
                                        _self.editor.addListener("contentChange", function() {
                                            ctrl.$setViewValue(_self.editor.getContent());
                                            if (!_updateByRender) {
                                                if (!$S.$$phase) {
                                                    $S.$apply();
                                                }
                                            }
                                            _updateByRender = false;
                                        });
                                        if (_self.modelContent && _self.modelContent.length > 0) {
                                            _self.setEditorContent();
                                        }
                                        if (typeof $S.ready === "function") {
                                            $S.ready(_self.editor);
                                        }
                                        $S.$on('$destroy', function() {
                                            _self.delEditor(_editorId);
                                        });
                                        $S.$on('destroy_ueditor', function() {
                                            _self.delEditor(_editorId);
                                        });
                                    });
                                }, 200);
                            };

                            _NGUeditor.prototype.setEditorContent = function(content) {
                                if (content == null) {
                                    content = this.modelContent;
                                }
                                if (this.editor && this.editorReady) {
                                    try {
                                        this.editor.setContent(content);
                                    } catch (e) {
                                    }
                                }
                            };

                            _NGUeditor.prototype.bindRender = function() {
                                var _self = this;
                                ctrl.$render = function() {
                                    if (!ctrl.$isEmpty(ctrl.$viewValue)) {
                                        _self.modelContent = (ctrl.$isEmpty(ctrl.$viewValue) ? "" : ctrl.$viewValue);
                                        _updateByRender = true;
                                        _self.setEditorContent();
                                    }
                                };
                            };

                            return _NGUeditor;

                        })();

                        if (typeof UE != 'undefined') {
                            new _NGUeditor();
                        } else {
                            window.UEDITOR_HOME_URL = '/static/components/ui_ueditor/';
                            Landers.loader.js(window.UEDITOR_HOME_URL + 'ueditor.all.min.js', function(){
                                new _NGUeditor();
                            })
                        }
                    }
                };
        });
    })();

}).call(this);


// //# sourceMappingURL=angular-ueditor.js.map



// angular.module("ng.ueditor", [])
//       .directive("ueditor", [
//         '$rootScope',
//         function($rootScope) {
//             return {
//                 restrict: 'EA',
//                 require: 'ngModel',
//                 link: function(scope, ele, attrs, ctrl) {
//                     $rootScope.$emit('loading', '初始化编辑器...');//广播loading事件，可以删除
//                     var _self = this,
//                             _initContent,
//                             editor,
//                             editorReady = false,
//                             base = '/public/vendor/utf8_qiniu_ueditor-master', //ueditor目录
//                             _id = attrs.ueditor;
//                     var editorHandler = {
//                         init: function() {
//                             window.UEDITOR_HOME_URL = base + '/';
//                             var _self = this;
//                             if (typeof UE != 'undefined') {
//                                 editor = UE.getEditor(_id);
//                                 editor.ready(function() {
//                                     editor.setHeight(500);
//                                     editorReady = true;
//                                     $rootScope.$emit('loading', '');//编辑器初始化完成
//                                     editor.addListener('contentChange', function() {//双向绑定
//                                         if (!scope.$$phase) {
//                                             scope.$apply(function() {
//                                                 ctrl.$setViewValue(editor.getContent());
//                                             });
//                                         }
//                                     });
//                                 });
//                             }
//                             else {
//                                 Common.loadScript(base + '/ueditor.config.js', null);
//                                 Common.loadScript(base + '/ueditor.all.min.js', function() {
//                                     _self.init();
//                                 });
//                             }
//                         },
//                         setContent: function(content) {
//                             if (editor && editorReady) {
//                                 editor.setContent(content);
//                             }
//                         }
//                     };
//                     ctrl.$render = function() {
//                         _initContent = ctrl.$isEmpty(ctrl.$viewValue) ? '' : ctrl.$viewValue;
//                         editorHandler.setContent(_initContent);//双向绑定
//                     };
//                     editorHandler.init();
//                     //事件
//                     $rootScope.$on('$routeChangeStart', function() {
//                         editor && editor.destroy();
//                     });
//                 }
//             }
//         }
//     ]);

angular.module('Landers.angular')
    .factory('LwapService', function($rootScope, BaseService){
        function LwapService(scope, key2) {
            this.__proto__ = BaseService.make(scope);
            this.apiurl = $rootScope.$path.appapi(key2);
            this.ajaxGet = function(params){
                var me = this;
                return me.ajax.get(me.apiurl, params || {});
            }
        };
        return {
            make : function(scope, key2) {
                return new LwapService(scope, key2);
            }
        };
    })
    .directive('crudDoItem', function(){
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                $element.addClass('doitem')
                    .children('a, button').not('.btn').addClass('btn ')
                    .each(function(){
                        if ($(this).attr('class').indexOf('btn-') < 0 ) {
                            $(this).addClass('btn-primary');
                        }
                    })
            }
        }
    })
    .factory('LwapApp', function ($state, AngularApp, $rootScope, Flat) {

        function LwapApp(scope, config) {

            var prop = config.prop || $state.$current.data;
            config.key = prop.key1;
            config.path = prop.key2;
            config.name = prop.name;
            config.url_style = 'lwap';
            config.dialog = $.extend(true, config.dialog || {}, {
                partial: 'addedit'
            });

            var that = this;
            this.__proto__ = AngularApp.make(scope, config);
            this.prop = prop;
            this.list = that.model ? that.model.list : null;

            scope.$currentApp = that;

            if (config.is_active) {
                setTimeout(function(){$rootScope.$activeApp = that;}, 200);
            }

            scope.$enums = angular.extend({}, $rootScope.$enums || {});
            this.enums = {
                __proto__ : Flat.make(scope, scope.$enums)
            };
        };

        return {
            make: function(scope, config){
                return new LwapApp(scope, config);
            },
            loadUrls: function(urls, callback){
                if (urls && !angular.isArray(urls)) urls = [urls];
                if (!urls || !urls.length) return callback();
                var promises = [];
                angular.forEach(urls, function(path){
                    var defer = $q.defer();
                    promises.push(defer.promise);
                    (function(defer){
                        $templateRequest(path).then(function(tpl){
                            defer.resolve(tpl);
                        });
                    })(defer);
                });
                $q.all(promises).then(callback);
            },
            loadAppPartial : function(key2, is_private, partial, callback) {
                var url = $rootScope.$path.apptpl(key2, is_private, partial);
                this.loadUrls(url, callback);
            }
        }
    });