;angular.module('Landers.angular')
    .directive('landersNameValueInputer', function($compile, Flat, Dialog, List) {
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                var model_key = $attrs['nviModel'];
                var view_key = $attrs['nviView'];

                var html = '';
                html += '<div class="relative">';
                html += '   <a ng-click="landersNameValuesAdd($event)" class="btn btn-sm btn-primary absolute right-top"><i class="glyphicon glyphicon-plus"></i></a>';
                html += '</div>';
                html += '<ul class="hlist list">';
                html += '    <li ng-repeat="item in ' + view_key + '" class="mr20 mb5 list-item">';
                html += '        <span class="">{{item.name}}：{{item.value}}</span>';
                html += '        <a ng-click="landersNameValuesRemove($event)" class="btn btn-warning btn-xs ml5"><i class="glyphicon glyphicon-minus"></i></a>';
                html += '    </li>';
                html += '</ul>';
                html += '<input ng-model="' + model_key + '" type="hidden"/>';

                var el = $compile(html)($scope);
                $element.css({height:'100%'}).append(el);
                if (!$scope.$$phase) $scope.$apply();
                $element.find('.list').css({'margin-right':$element.find('.btn').width() + 20 })

                var lister = List.make($scope, view_key).data([]);
                $scope.$watch(model_key, function(model){
                    if (model) lister.data(model);
                });

                var html = '';
                html += '<form class="form-horizontal">';
                html += '   <table cellpadding="0" cellspacing="0" border="0" class="stereo form-table">';
                html += '   <tr>';
                html += '       <td><label class="control-label">名称</label></td>';
                html += '       <td><div class="control-input"><input ng-model="$runtime.nvi.name" maxlength="30" value="" type="text" class="form-control"/></div></td>';
                html += '   </tr>';
                html += '   <tr>';
                html += '       <td><label class="control-label">数据</label></td>';
                html += '       <td><div class="control-input"><textarea ng-model="$runtime.nvi.value" value="" type="text" class="form-control"></textarea></div></td>';
                html += '   </tr>';
                html += '   </table>';
                html += '</form>';
                angular.extend($scope, {
                    landersNameValuesAdd : function(){
                        Flat.set($scope, '$runtime.nvi', {});
                        setTimeout(function(){
                            Dialog.show($scope, {
                                title   : $attrs['nviName'],
                                content : html,
                                width   : 350,
                                lock    : true,
                                fixed   : true,
                                effect  : 'vmove1',
                                onload  : function(){
                                },
                                yes     : function(){
                                    var nvi = Flat.get($scope, '$runtime.nvi');
                                    lister.append(angular.extend({}, nvi));
                                    Flat.set($scope, model_key, angular.toJson(lister.data()));
                                },
                                no      : true
                            });
                        }, 200);
                    },
                    landersNameValuesRemove : function($event){
                        lister.item.remove($event);
                        Flat.set($scope, model_key, angular.toJson(lister.data()));
                    }
                })
            }
        }
    });