
// /**
// Created by Dio on 17-9.
// http://inhu.net
//  */

(function() {
    "use strict";
    (function() {
        var NGUeditor, Editors = {};
        NGUeditor = angular.module("ng.ueditor", []);
        NGUeditor.directive("ueditor", function($timeout) {
                return {
                    restrict: "C",
                    require: "ngModel",
                    scope: {
                        config: "=",
                        ready: "="
                    },
                    link: function($S, element, attr, ctrl) {
                        var _NGUeditor, _updateByRender;
                        _updateByRender = false;
                        _NGUeditor = (function() {
                            function _NGUeditor() {
                                this.bindRender();
                                this.initEditor();
                                return;
                            }

                            /**
                             * 初始化编辑器
                             * @return {[type]} [description]
                             */
                            _NGUeditor.prototype.delEditor = function(_editorId) {
                                if (UE.delEditor && Editors[_editorId]) {
                                    Editors[_editorId].removeListener("contentChange");
                                    UE.delEditor(_editorId);
                                    Editors[_editorId] = null;
                                    delete Editors[_editorId];
                                    this.editor = null;
                                }
                            };

                            _NGUeditor.prototype.initEditor = function() {
                                var _UEConfig, _editorId, _self;
                                _self = this;
                                if (typeof UE === 'undefined') {
                                    console.error("Please import the local resources of ueditor!");
                                    return;
                                }
                                _UEConfig = $S.config ? $S.config : {};
                                _editorId = attr.id ? attr.id : "_editor" + (Date.now());
                                element[0].id = _editorId;
                                if (Editors[_editorId]) {
                                    _self.delEditor(_editorId);
                                };
                                $timeout(function(){
                                    _self.editor = new UE.ui.Editor(_UEConfig);
                                    Editors[_editorId] = _self.editor;
                                    _self.editor.render(_editorId);
                                    _self.editor.ready(function() {
                                        _self.editorReady = true;
                                        _self.editor.addListener("contentChange", function() {
                                            ctrl.$setViewValue(_self.editor.getContent());
                                            if (!_updateByRender) {
                                                if (!$S.$$phase) {
                                                    $S.$apply();
                                                }
                                            }
                                            _updateByRender = false;
                                        });
                                        if (_self.modelContent && _self.modelContent.length > 0) {
                                            _self.setEditorContent();
                                        }
                                        if (typeof $S.ready === "function") {
                                            $S.ready(_self.editor);
                                        }
                                        $S.$on('$destroy', function() {
                                            _self.delEditor(_editorId);
                                        });
                                        $S.$on('destroy_ueditor', function() {
                                            _self.delEditor(_editorId);
                                        });
                                    });
                                }, 200);
                            };

                            _NGUeditor.prototype.setEditorContent = function(content) {
                                if (content == null) {
                                    content = this.modelContent;
                                }
                                if (this.editor && this.editorReady) {
                                    try {
                                        this.editor.setContent(content);
                                    } catch (e) {
                                    }
                                }
                            };

                            _NGUeditor.prototype.bindRender = function() {
                                var _self = this;
                                ctrl.$render = function() {
                                    if (!ctrl.$isEmpty(ctrl.$viewValue)) {
                                        _self.modelContent = (ctrl.$isEmpty(ctrl.$viewValue) ? "" : ctrl.$viewValue);
                                        _updateByRender = true;
                                        _self.setEditorContent();
                                    }
                                };
                            };

                            return _NGUeditor;

                        })();

                        if (typeof UE != 'undefined') {
                            new _NGUeditor();
                        } else {
                            window.UEDITOR_HOME_URL = '/static/components/ui_ueditor/';
                            Landers.loader.js(window.UEDITOR_HOME_URL + 'ueditor.all.min.js', function(){
                                new _NGUeditor();
                            })
                        }
                    }
                };
        });
    })();

}).call(this);


// //# sourceMappingURL=angular-ueditor.js.map



// angular.module("ng.ueditor", [])
//       .directive("ueditor", [
//         '$rootScope',
//         function($rootScope) {
//             return {
//                 restrict: 'EA',
//                 require: 'ngModel',
//                 link: function(scope, ele, attrs, ctrl) {
//                     $rootScope.$emit('loading', '初始化编辑器...');//广播loading事件，可以删除
//                     var _self = this,
//                             _initContent,
//                             editor,
//                             editorReady = false,
//                             base = '/public/vendor/utf8_qiniu_ueditor-master', //ueditor目录
//                             _id = attrs.ueditor;
//                     var editorHandler = {
//                         init: function() {
//                             window.UEDITOR_HOME_URL = base + '/';
//                             var _self = this;
//                             if (typeof UE != 'undefined') {
//                                 editor = UE.getEditor(_id);
//                                 editor.ready(function() {
//                                     editor.setHeight(500);
//                                     editorReady = true;
//                                     $rootScope.$emit('loading', '');//编辑器初始化完成
//                                     editor.addListener('contentChange', function() {//双向绑定
//                                         if (!scope.$$phase) {
//                                             scope.$apply(function() {
//                                                 ctrl.$setViewValue(editor.getContent());
//                                             });
//                                         }
//                                     });
//                                 });
//                             }
//                             else {
//                                 Common.loadScript(base + '/ueditor.config.js', null);
//                                 Common.loadScript(base + '/ueditor.all.min.js', function() {
//                                     _self.init();
//                                 });
//                             }
//                         },
//                         setContent: function(content) {
//                             if (editor && editorReady) {
//                                 editor.setContent(content);
//                             }
//                         }
//                     };
//                     ctrl.$render = function() {
//                         _initContent = ctrl.$isEmpty(ctrl.$viewValue) ? '' : ctrl.$viewValue;
//                         editorHandler.setContent(_initContent);//双向绑定
//                     };
//                     editorHandler.init();
//                     //事件
//                     $rootScope.$on('$routeChangeStart', function() {
//                         editor && editor.destroy();
//                     });
//                 }
//             }
//         }
//     ]);
