angular.module('Landers.angular')
    .factory('LwapService', function($rootScope, BaseService){
        function LwapService(scope, key2) {
            this.__proto__ = BaseService.make(scope);
            this.apiurl = $rootScope.$path.appapi(key2);
            this.ajaxGet = function(params){
                var me = this;
                return me.ajax.get(me.apiurl, params || {});
            }
        };
        return {
            make : function(scope, key2) {
                return new LwapService(scope, key2);
            }
        };
    })
    .directive('crudDoItem', function(){
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                $element.addClass('doitem')
                    .children('a, button').not('.btn').addClass('btn ')
                    .each(function(){
                        if ($(this).attr('class').indexOf('btn-') < 0 ) {
                            $(this).addClass('btn-primary');
                        }
                    })
            }
        }
    })
    .factory('LwapApp', function ($state, AngularApp, $rootScope, Flat) {

        function LwapApp(scope, config) {

            var prop = config.prop || $state.$current.data;
            config.key = prop.key1;
            config.path = prop.key2;
            config.name = prop.name;
            config.url_style = 'parallelism';
            config.dialog = $.extend(true, config.dialog || {}, {
                partial: 'addedit'
            });

            var that = this;
            this.__proto__ = AngularApp.make(scope, config);
            this.prop = prop;
            this.list = that.model ? that.model.list : null;

            scope.$currentApp = that;

            if (config.is_active) {
                setTimeout(function(){$rootScope.$activeApp = that;}, 200);
            }

            scope.$enums = angular.extend({}, $rootScope.$enums || {});
            this.enums = {
                __proto__ : Flat.make(scope, scope.$enums)
            };
        };

        return {
            make: function(scope, config){
                return new LwapApp(scope, config);
            },
            loadUrls: function(urls, callback){
                if (urls && !angular.isArray(urls)) urls = [urls];
                if (!urls || !urls.length) return callback();
                var promises = [];
                angular.forEach(urls, function(path){
                    var defer = $q.defer();
                    promises.push(defer.promise);
                    (function(defer){
                        $templateRequest(path).then(function(tpl){
                            defer.resolve(tpl);
                        });
                    })(defer);
                });
                $q.all(promises).then(callback);
            },
            loadAppPartial : function(key2, is_private, partial, callback) {
                var url = $rootScope.$path.apptpl(key2, is_private, partial);
                this.loadUrls(url, callback);
            }
        }
    });