;angular.module('Landers.angular')
    .factory('RouteMenu', ['$state', function($state){
            function RouteMenu( selector ){
                var that = this;

                this.getMenu = function( callback ){
                    var $menu = $(selector);

                    if ( !$menu.length || !$menu.children().length) {
                        var self = arguments.callee;
                        setTimeout(function(){
                            self(callback);
                        }, 300);
                    } else {
                        callback && callback( $menu );
                    }

                    return that;
                };

                this.findForActive = function(callback){
                    var active_states = $state.current.activeStates;
                    if ( !active_states || !active_states.length ) {
                        active_states = [ $state.current.name ];
                    }

                    that.getMenu( function( $menu ){
                        angular.forEach(active_states, function(state){
                            var $o = $menu.find("[ui-sref^='" + state + "(']");
                            callback && callback( $o );
                        });
                    });

                    return that;
                }
            }

            return {
                make: function(selector){
                    return new RouteMenu(selector);
                }
            }
        }]);